#include	<stddef.h>
#include	<ctype.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

#include	"mckc.h"

extern char	fname[_num][256];
extern int	debug_flag;
extern char ef_name[256];
extern char inc_name[256];
extern int	ef_out_flag;
extern int	warning_flag;
extern int	message_flag;
extern int	include_flag;

extern void splitPath( char *ptr, char *path, char *name, char *ext );
extern int	getFileSize( char *ptr );
extern int  Asc2Int( char *ptr, int *cnt );
extern void strupper( char *ptr );
extern char *readFile( char *filename, char *atr );
extern char *skipSpace( char *ptr );

int		error_flag;					// G[Ă0ȊO
int		octave;						// ϊ̃IN^[u
double	length;						// ϊ̉
int		octave_flag = 0;			// IN^[uXCb` ("<" ">" ̏)
int		loop_flag;					// `l[v0ȊO
int		x;
int		nest;						// s[g̃lXg
LEN		track_count[_TRACK_MAX][2];			// g[^ۊǏꏊ(/t[/[v/[vt[)

int		volume_flag;				// ʂ̏ 0:ڎw 1:Gx[vw
double		tbase = 0.625;						// ϊ[frame/count]

int		transpose;					// ݂̃gX|[Yl

int		sndgen_flag = 0;			// gtO
// gbNtO
unsigned long	track_allow_flag = (TRACK(0)|TRACK(1)|TRACK(2)|NOISETRACK|DPCMTRACK);
//ۂɎggbN
unsigned long	actual_track_flag = 0;
int		dpcm_track_num = 1;			// DPCMgbN
int		fds_track_num = 0;			// FDSgbN
int		vrc7_track_num = 0;			// VRC7gbN
int		vrc6_track_num = 0;			// VRC6gbN
int		n106_track_num = 0;			// g(namco106)gpgbN
int		fme7_track_num = 0;			// FME7gbN
int		mmc5_track_num = 0;			// MMC5gbN

int		bank_change[3]	= { 0xff, 0xff, 0xff };	// oN؂ւgbN


int		bank_sel[_TRACK_MAX];	// 0x00 - 0xFE = oN؂ւ , 0xFF = ύX

int		compatible_bkchg = 0;	//1mckc027̃oN`FWgp

int		curr_bank = 0x00;
int		env = -1;				// ݂̃\tgGx[vԍ(-1:gp/0-255) 
int		rel_env = -1;			// ݂̃[XGx[vԍ(-1:gp/0-255) 
int		now_env = -1;			// ݂̃\tgGx[vԍ(-1:gp/0-255) 

int tone_tbl[          _TONE_MAX][1024];	// Tone
int envelope_tbl[  _ENVELOPE_MAX][1024];	// Envelope
int pitch_env_tbl[_PITCH_ENV_MAX][1024];	// Pitch Envelope
int pitch_mod_tbl[_PITCH_MOD_MAX][   5];	// LFO
int arpeggio_tbl[  _ARPEGGIO_MAX][1024];	// Arpeggio
int fm_tone_tbl[    _FM_TONE_MAX][2+64];	// FM Tone
int vrc7_tone_tbl[_VRC7_TONE_MAX][2+64];	// VRC7 Tone(z񐔂͎gp֐̊֌Wj
int n106_tone_tbl[_N106_TONE_MAX][2+64];	// NAMCO106 Tone
int hard_effect_tbl[_HARD_EFFECT_MAX][5];	// FDS Hardware Effect
int effect_wave_tbl[_EFFECT_WAVE_MAX][33];	// Effect Wave (4088) Data

DPCMTBL	dpcm_tbl[_DPCM_MAX];				// DPCM
unsigned char	dpcm_data[_DPCM_TOTAL_SIZE];	// DPCMWJf[^
int	dpcm_size = 0;

char	song_name[1024] = "Song Name\0";
char	composer[1024] = "Artist\0";
char	maker[1024] = "Maker\0";

const	char	str_track[] = _TRACK_STR;

// G[ԍ
enum {
	COMMAND_NOT_DEFINED = 0,
	DATA_ENDED_BY_LOOP_DEPTH_EXCEPT_0,
	DEFINITION_IS_WRONG,
	TONE_DEFINITION_IS_WRONG,
	ENVELOPE_DEFINITION_IS_WRONG,
	PITCH_ENVELOPE_DEFINITION_IS_WRONG,
	NOTE_ENVELOPE_DEFINITION_IS_WRONG,
	LFO_DEFINITION_IS_WRONG,
	DPCM_DEFINITION_IS_WRONG,
	DPCM_PARAMETER_IS_LACKING,
	FM_TONE_DEFINITION_IS_WRONG,
	ABNORMAL_PARAMETERS_OF_FM_TONE,
	N106_TONE_DEFINITION_IS_WRONG,
	ABNORMAL_PARAMETERS_OF_N106_TONE,
	ABNORMAL_VALUE_OF_REPEAT_COUNT,
	ABNORMAL_TONE_NUMBER,
	ABNORMAL_ENVELOPE_NUMBER,
	ABNORMAL_ENVELOPE_VALUE,
	ABNORMAL_PITCH_ENVELOPE_NUMBER,
	ABNORMAL_NOTE_ENVELOPE_NUMBER,
	ABNORMAL_LFO_NUMBER,
	ABNORMAL_PITCH_VALUE,
	ABNORMAL_VOLUME_VALUE,
	ABNORMAL_TEMPO_VALUE,
	ABNORMAL_QUANTIZE_VALUE,
	ABNORMAL_SWEEP_VALUE,
	ABNORMAL_DETUNE_VALUE,
	RELATIVE_VOLUME_WAS_USED_WITHOUT_SPECIFYING_VOLUME,
	VOLUME_RANGE_OVER_OF_RELATIVE_VOLUME,
	VOLUME_RANGE_UNDER_OF_RELATIVE_VOLUME,
	DATA_ENDED_BY_CONTINUATION_NOTE,
	DPCM_FILE_NOT_FOUND,
	DPCM_FILE_SIZE_OVER,
	DPCM_FILE_TOTAL_SIZE_OVER,
	INVALID_TRACK_HEADER,
	HARD_EFFECT_DEFINITION_IS_WRONG,
	EFFECT_WAVE_DEFINITION_IS_WRONG,
	ABNORMAL_HARD_EFFECT_NUMBER,
	ABNORMAL_TRANSPOSE_VALUE,
	TUPLET_BRACE_EMPTY,
};

// G[
const	char	*ErrorlMessage[] = {
	"w̃R}h͂܂",							"Command not defined",
	"[v[x0ȊOŃf[^I܂",				"Data ended by loop depth except 0",
	"ݒɌ肪܂",									"Definition is wrong",
	"PSGFݒɌ肪܂",							"PSG Tone definition is wrong",
	"Gx[vݒɌ肪܂",						"Envelope definition is wrong",
	"sb`Gx[vݒɌ肪܂",				"Pitch envelope definition is wrong",
	"m[gGx[vݒɌ肪܂",				"Note envelope definition is wrong",
	"LFOݒɌ肪܂",								"LFO definition is wrong",
	"DPCMݒɌ肪܂",								"DPCM definition is wrong",
	"DPCMݒ̃p[^܂",						"DPCM parameter is lacking",
	"FMFݒɌ肪܂",							"FM tone definition is wrong",
	"FMpF̃p[^ُł",						"Abnormal parameters of FM tone",
	"namco106FݒɌ肪܂",						"namco106 tone definition is wrong",
	"namco106pF̃p[^ُł",					"Abnormal parameters of namco106 tone",
	"JԂ񐔂̒lُł",							"Abnormal value of repeat count",
	"Fԍُł",									"Abnormal tone number",
	"Gx[vԍُł",							"Abnormal envelope number",
	"Gx[v̒lُł",							"Abnormal envelope value",
	"sb`Gx[vԍ̒lُł",					"Abnormal pitch envelope number",
	"m[gGx[vԍ̒lُł",					"Abnormal note envelope number",
	"LFOԍ̒lُł",								"Abnormal LFO number",
	"̒lُł",									"Abnormal pitch value",
	"ʂ̒lُł",									"Abnormal volume value",
	"e|̒lُł",									"Abnormal tempo value",
	"NH^CY̒lُł",							"Abnormal quantize value",
	"XC[v̒lُł",								"Abnormal sweep value",
	"fB`[̒lُł",							"Abnormal detune value",
	"ʂw肳ĂȂԂőΉʂgp܂",	"Relative volume was used without specifying volume",
	"Ή(+)ŉʂ͈̔͂𒴂܂",					"Volume range over(+) of relative volume",
	"Ή(-)ŉʂ͈̔͂𒴂܂",					"Volume range under(-) of relative volume",
	"A̓rŃf[^I܂",					"Data ended by Continuation note",
	"DPCMt@C܂",								"DPCM file not found",
	"DPCMf[^̃TCY4081byte𒴂܂",				"DPCM file size over",
	"DPCMf[^̃TCYK̃TCY𒴂܂",			"DPCM file total size over",
	"w̃gbNwb_͖ł",						"Invalid track header",
	"n[hEFAGtFNgݒɌ肪܂B",			"Hardware effect definition is wrong",
	"GtFNgg`ݒɌ肪܂B",					"Effect wavetable definition is wrong",
	"n[hEFAGtFNgԍ̒lُłB",			"Abnormal hardware effect number",
	"gX|[Y̒lُł",							"Abnormal transpose value",
	"A{}̒ɉ܂",						"Tuplet {} empty",
};



enum {
	TOO_MANY_INCLUDE_FILES = 0,
	UNUSE_COMMAND_IN_THIS_TRACK,
	FRAME_LENGTH_IS_0,
	REPEAT2_FRAME_ERROR_OVER_3,
	IGNORE_PMCKC_BANK_CHANGE,
};

const	char	*WarningMessage[] = {
	"CN[ht@C̐܂",					"Too many include files",
	"̃gbNł͎gpłȂR}hł",				"Unuse command in this track",
	"t[0ɂȂ܂B",						"frame length is 0",
	"s[g2̃t[덷3t[𒴂Ă܂B",	"Repeat2 frame error over 3 frames",
	"#BANK-CHANGEgp#SETBANK, NB͖܂",		"Ignoring #SETBANK and NB if #BANK-CHANGE used",
};



/*--------------------------------------------------------------
	G[\
 Input:
	
 Output:
	none
--------------------------------------------------------------*/
void dispError( int no, char *file, int line )
{
	no = no*2;
	if( message_flag != 0 ) {
		no++;
	}
	if( file != NULL ) {
		printf( "Error  : %s %6d: %s\n", file, line, ErrorlMessage[no] );
	} else {
		printf( "Error  : %s\n", ErrorlMessage[no] );
	}
	error_flag = 1;
}



/*--------------------------------------------------------------
	[jO\
 Input:
	
 Output:
	none
--------------------------------------------------------------*/
void dispWarning( int no, char *file, int line )
{
	if( warning_flag != 0 ) {
		no = no*2;
		if( message_flag != 0 ) {
			no++;
		}
		printf( "Warning: %s %6d: %s\n", file, line, WarningMessage[no] );
	}
}



/*--------------------------------------------------------------
	C^Cṽ}[N̍폜
 Input:
	char	*ptr		:f[^i[|C^
 Output:
	none
--------------------------------------------------------------*/
void deleteCRemark( char *ptr )
{
	int within_com = 0;
	while ( *ptr != '\0' ) {
		if ( *ptr == '/' && *(ptr + 1) == '*' ) {
			within_com = 1;
			*ptr++ = ' ';
			*ptr++ = ' ';
			while (*ptr) {
				if (*ptr == '*' && *(ptr + 1) == '/') {
					*ptr++ = ' ';
					*ptr++ = ' ';
					within_com = 0;
					break;
				}
				if ( *ptr != '\n' ) {
					*ptr = ' ';
				}
				ptr++;
			}
		} else {
			++ptr;
		}
	}
	if (within_com) {
		printf("Warning :");
		printf( message_flag 	? "Reached EOF in comment"
					: "RgȂ܂܃t@CI[ɒB܂");
		printf("\n");
	}
}



/*--------------------------------------------------------------
	}[N̍폜
 Input:
	char	*ptr	:f[^i[|C^
 Output:
	
--------------------------------------------------------------*/
void deleteRemark( char *ptr )
{
	while( *ptr != '\0' ) {
		if ( *ptr == '/' || *ptr == ';' ) {
			while( *ptr != '\0' ) {
				if( *ptr != '\n' ) {
					*ptr++ = ' ';
				} else {
					ptr++;
					break;
				}
			}
		} else {
			ptr++;
		}
	}
}



/*----------------------------------------------------------*/
/*	t@Cs߂								    */
/* Input:												    */
/*	char	*data		:f[^i[|C^				    */
/* Output:												    */
/*	none												    */
/*----------------------------------------------------------*/
int getLineCount( char *ptr )
{
	int	line;

	line = 0;

	while( *ptr != '\0' ) {
		if( *ptr == '\n' ) {
			line++;
		}
		ptr++;
	}
	if( *(ptr-1) != '\n' ) {
		line++;
	}
	return line;
}



/*--------------------------------------------------------------
	s/EOF0(NULL)ɂ(obt@sPʂŐ؂蕪)
 Input:
	char	*ptr	:f[^i[|C^
 Output:
	
--------------------------------------------------------------*/
char *changeNULL( char *ptr )
{
	while( *ptr != '\n' ) {
		if( *ptr == '\0' ) break;
		ptr++;
	}
	*ptr = '\0';
	ptr++;

	return ptr;
}


/*--------------------------------------------------------------
	wb_[߂
 Input:
	char	*ptr	:f[^i[|C^
 Output:
	
--------------------------------------------------------------*/
void getLineStatus( char *ptr, LINE *lptr, int inc_nest )
{
	const HEAD head[] = {
		{ "#TITLE",          _TITLE          },
		{ "#COMPOSER",       _COMPOSER       },
		{ "#MAKER",          _MAKER          },
		{ "#PROGRAMER",      _PROGRAMER      },
		{ "#OCTAVE-REV",     _OCTAVE_REV     },
		{ "#INCLUDE",        _INCLUDE        },
		{ "#EX-DISKFM",      _EX_DISKFM      },
		{ "#EX-NAMCO106",    _EX_NAMCO106    },
		{ "#EX-VRC7",		 _EX_VRC7		 },
		{ "#EX-VRC6",		 _EX_VRC6		 },
		{ "#EX-FME7",		 _EX_FME7		 },
		{ "#EX-MMC5",		 _EX_MMC5		 },
		{ "#BANK-CHANGE",    _BANK_CHANGE    },
		{ "#SETBANK",    	 _SET_SBANK	     },
		{ "#EFFECT-INCLUDE", _EFFECT_INCLUDE },
		{ "@DPCM",           _SET_DPCM_DATA  },
		{ "@MP",             _SET_PITCH_MOD  },
		{ "@EN",             _SET_ARPEGGIO   },
		{ "@EP",             _SET_PITCH_ENV  },
		{ "@FM",             _SET_FM_TONE    },
		{ "@MH",             _SET_HARD_EFFECT},
		{ "@MW",             _SET_EFFECT_WAVE},
		{ "@OP",             _SET_VRC7_TONE  },
		{ "@N",              _SET_N106_TONE  },			
		{ "@V",              _SET_ENVELOPE   },
		{ "@",               _SET_TONE       },
		{ "",                -1              },
	};

	int		line, i, inc_line, param, cnt, track_flag, status_end_flag, bank,bank_ch;
	char	*inc_ptr, *temp, *temp2;

	status_end_flag = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		ptr = skipSpace( ptr );
		/* O̍sGtFNg`H */
		if( ((lptr[line-1].status&_SET_EFFECT) != 0) && (status_end_flag != 0) ) {
			lptr[line].status = lptr[line-1].status|_SAME_LINE;
			lptr[line].param  = lptr[line-1].param;
			lptr[line].str = ptr;
			temp = ptr;
			ptr = changeNULL( ptr );
			status_end_flag = 1;
			while( *temp != '\0' ) {
				if( *temp == '}' ) {
					status_end_flag = 0;
				}
				temp++;
			}
		/* s̐擪ɉ͖ȍsƂ */
		} else if( *ptr == '\n' || *ptr == '\0' ) {
			lptr[line].status = 0;
			lptr[line].str = ptr;
			ptr = changeNULL( ptr );
		} else {
			/* #/@twb_[̎̓wb_[̕啶ɂ */
			if( *ptr == '#' || *ptr == '@' ) {
				i = 1;
				while( (*(ptr+i) != ' ') && (*(ptr+i) != '\t') && (*(ptr+i) != '\n') ) {
					*(ptr+i) = (char)toupper( *(ptr+i) );
					i++;
				}
				/* wb_[e[uƔr */
				for( i = 0; head[i].status != -1; i++ ) {
					if( strncmp( ptr, head[i].str, strlen(head[i].str) ) == 0 ) {
						break;
					}
				}
				lptr[line].status = head[i].status;
				lptr[line].str = skipSpace( ptr+strlen(head[i].str) );	/* wb_[{󔒂΂Ƃ擪 */
			} else if( strchr( str_track, *ptr ) ) {
				track_flag = 0;
				while( strchr( str_track, *ptr ) ) {
					temp = strchr( str_track, *ptr );
					if( temp == NULL ) {
						dispError( INVALID_TRACK_HEADER, lptr[line].filename, line );
					} else {
						track_flag |= (1<<(temp-str_track));
					}
					ptr++;
				}
#if 0
				// FMgbN̃`FbN
				if( ((track_flag&FMTRACK) != 0) && ((sndgen_flag&BDISKFM) == 0) ) {
					dispError( INVALID_TRACK_HEADER, lptr[line].filename, line );
					track_flag &= ~FMTRACK;
				}

				// VRC7gbN̃`FbN
				if( ((track_flag&VRC7TRACK) != 0) && ((sndgen_flag&BVRC7) == 0) ) {
					dispError( INVALID_TRACK_HEADER, lptr[line].filename, line );
					track_flag &= ~VRC7TRACK;
				}
				
				// VRC6gbN̃`FbN
				if( ((track_flag&VRC6TRACK) != 0) && ((sndgen_flag&BVRC6) == 0) ) {
					dispError( INVALID_TRACK_HEADER, lptr[line].filename, line );
					track_flag &= ~VRC6TRACK;
				}
				
				// namco106gbN̃`FbN
				if( ((track_flag&N106TRACK) != 0) && ((sndgen_flag&BNAMCO106) == 0) ) {
					dispError( INVALID_TRACK_HEADER, lptr[line].filename, line );
					track_flag &= ~N106TRACK;
				}
				
				// FME7gbN̃`FbN
				if( ((track_flag&FME7TRACK) != 0) && ((sndgen_flag&BFME7) == 0) ) {
					dispError( INVALID_TRACK_HEADER, lptr[line].filename, line );
					track_flag &= ~FME7TRACK;
				}

				// MMC5gbN̃`FbN
				if( ((track_flag&MMC5TRACK) != 0) && ((sndgen_flag&BMMC5) == 0) ) {
					dispError( INVALID_TRACK_HEADER, lptr[line].filename, line );
					track_flag &= ~MMC5TRACK;
				}
#endif
				// gbN̃`FbN
				for (i = 0; i < _TRACK_MAX; i++) {
					if( (TRACK(i) & track_flag) && !(TRACK(i) & track_allow_flag) ) {
						dispError( INVALID_TRACK_HEADER, lptr[line].filename, line );
						track_flag &= ~TRACK(i);
					}
				}
				
				if( track_flag != 0 ) {
					lptr[line].status = _TRACK;
					lptr[line].param = track_flag;
					lptr[line].str = skipSpace( ptr );
					actual_track_flag |= track_flag;				
				} else {
					lptr[line].status = 0;
					lptr[line].param = 0;
				}
			} else {
				lptr[line].status = -1;
				lptr[line].str = skipSpace( ptr );
			}
			ptr = changeNULL( ptr );

			switch( lptr[line].status ) {
			/* IncludeR}h̏ */
			  case _INCLUDE:
				if( inc_nest > 16 ) {				/* lXg16i܂(ċAŌĂ΂ƏIȂ̂) */
					dispWarning( TOO_MANY_INCLUDE_FILES, lptr[line].filename, line );
					lptr[line].status = 0;
				} else {
					temp = lptr[line].str;						/* ]ȃXy[X폜 */
					while( *temp != ' ' && *temp != '\t' ) {
						temp++;
					}
					temp = '\0';

					inc_ptr = readFile( lptr[line].str, "rt" );	/* MMLt@Cǂݍ	*/
					if( inc_ptr != NULL ) {
						deleteCRemark( inc_ptr );				/* MMLf[^̃Rgs폜 */
						deleteRemark(  inc_ptr );

						inc_line = getLineCount( inc_ptr );		/* TEXTs擾	*/
						lptr[line].inc_ptr = malloc( (inc_line+1)*sizeof(LINE) );	/* Cobt@m */

						lptr[line].inc_ptr[0].status = _HEADER;		/* LINEXe[^X[0]mallocꂽ	*/
						lptr[line].inc_ptr[0].str    = inc_ptr;		/* |C^ƃTCYi[Ă */
						lptr[line].inc_ptr[0].line   = inc_line;
						lptr[line].inc_ptr[0].filename = lptr[line].str;
						for( i = 1; i <= inc_line; i++ ) {
							lptr[line].inc_ptr[i].filename = lptr[line].str;
							lptr[line].inc_ptr[i].line = i;
						}
						++inc_nest;
						getLineStatus( inc_ptr, lptr[line].inc_ptr, inc_nest );
						--inc_nest;
					} else {
						lptr[line].status = 0;					/* t@CǂݍݎsɕtG[ */
						error_flag = 1;
					}
				}
				break;
			/* LFOR}h */
			  case _SET_PITCH_MOD:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _PITCH_MOD_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( 	LFO_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( 	LFO_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			/* sb`Gx[vR}h */
			  case _SET_PITCH_ENV:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _PITCH_ENV_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( 	PITCH_ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( 	PITCH_ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			/* ʃGx[vR}h */
			  case _SET_ENVELOPE:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _ENVELOPE_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			/* 쉹F */
			  case _SET_TONE:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _TONE_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			/* AyWI */
			  case _SET_ARPEGGIO:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _ARPEGGIO_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( NOTE_ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( NOTE_ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			/* DPCMo^R}h */
			  case _SET_DPCM_DATA:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );				/* Fԍ */
				if( cnt != 0 && (0 <= param && param < _DPCM_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( DPCM_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( DPCM_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			  /* VRC7 Tone */
			  case _SET_VRC7_TONE:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _VRC7_TONE_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;

			/* FMF */
			  case _SET_FM_TONE:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _FM_TONE_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			/* namco106F */
			  case _SET_N106_TONE:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _N106_TONE_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( N106_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( N106_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			/* DISKSYSTEM FMgptO */
			  case _EX_DISKFM:
				sndgen_flag |= BDISKFM;
				track_allow_flag |= FMTRACK;
				fds_track_num = 1;
				break;
			/* VRC7 FMgptO */
			  case _EX_VRC7:
				sndgen_flag |= BVRC7;
				track_allow_flag |= VRC7TRACK;
				vrc7_track_num = 6;
				break;
			/* VRC6 gptO */
			  case _EX_VRC6:
				sndgen_flag |= BVRC6;
				track_allow_flag |= VRC6TRACK;
				vrc6_track_num = 3;
				break;
			/* FME7 gptO */
			  case _EX_FME7:
				sndgen_flag |= BFME7;
				track_allow_flag |= FME7TRACK;
				fme7_track_num = 3;
				break;
			/* MMC5 gptO */
			  case _EX_MMC5:
				sndgen_flag |= BMMC5;
				track_allow_flag |= MMC5TRACK;
				mmc5_track_num = 3;
				break;
			/* namco106 ggptO */
			  case _EX_NAMCO106:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param <= 8) ) {
					if( param == 0 ) {
						param = 1;
					}
					lptr[line].param = param;
					n106_track_num = param;
					sndgen_flag |= BNAMCO106;
					for (i = 0; i < param; i++) {
						track_allow_flag |= TRACK(BN106TRACK+i);
					}
				} else {
					dispError( DEFINITION_IS_WRONG, lptr[line].filename, line );
					lptr[line].status = 0;
				}
				break;
			/* oN؂ւߍ(b菈) */
			  case _BANK_CHANGE:
				compatible_bkchg = 1;
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 ) {
					temp += cnt;
					temp = skipSpace( temp );
					if( *temp == ',' ) {		/* oNg */
						temp++;
						if( (0 <= param) && (param <= 2) ) {
							bank = param;
							//printf( "bank: %d\n", bank );
							temp = skipSpace( temp );
							param = Asc2Int( temp, &cnt );
							if( cnt != 0 && (1 <= param && param <= 14) ) {
								bank_change[bank] = param-1;
							} else {
								dispError( DEFINITION_IS_WRONG, lptr[line].filename, line );
								lptr[line].status = 0;
								bank_change[bank] = 0xff;
							}
						} else {
							dispError( DEFINITION_IS_WRONG, lptr[line].filename, line );
							lptr[line].status = 0;
						}
					} else {
						if( cnt != 0 && (1 <= param && param <= 14) ) {
							bank_change[0] = param-1;
						} else {
							dispError( DEFINITION_IS_WRONG, lptr[line].filename, line );
							lptr[line].status = 0;
							bank_change[0] = 0xff;
						}
					}
				} else {
					dispError( DEFINITION_IS_WRONG, lptr[line].filename, line );
					lptr[line].status = 0;
				}					
				break;
			/* oN؂ւ */
			  case _SET_SBANK:
				if (compatible_bkchg) {
					dispWarning( IGNORE_PMCKC_BANK_CHANGE, lptr[line].filename, line );
					lptr[line].status = 0;
					break;
				}
				temp = skipSpace( lptr[line].str );
				
				if ((temp2 = strchr(str_track, *temp)) != NULL) {
					/* ABC..ɂgbNw */
					param = (temp2 - str_track) + 1;
					temp++;
				} else {
					/* ɂgbNw */
					param = Asc2Int( temp, &cnt );
					if (cnt == 0) {
						dispError( DEFINITION_IS_WRONG, lptr[line].filename, line );
						lptr[line].status = 0;
						break;
					} else {
						temp += cnt;
					}
				}
				
				temp = skipSpace( temp );
				if( *temp == ',' ) {		/* oNg */
					temp++;
					if( (1 <= param) && (param <= _TRACK_MAX) ) {
						bank_ch = param;
						// printf( "bank: %d\n", bank );
						temp = skipSpace( temp );
						param = Asc2Int( temp, &cnt );
						if( cnt != 0 && (0 <= param && param <= 0xff) ) {
							bank_sel[bank_ch-1] = param;
						} else {
							dispError( DEFINITION_IS_WRONG, lptr[line].filename, line );
							lptr[line].status = 0;
						}
					} else {
						dispError( DEFINITION_IS_WRONG, lptr[line].filename, line );
						lptr[line].status = 0;
					}
				} else {
					dispError( DEFINITION_IS_WRONG, lptr[line].filename, line );
					lptr[line].status = 0;
				}
				break;

			/* namco106 ggptO */
			  case _EFFECT_INCLUDE:
				include_flag = 1;
				break;
			/* n[hEFAGtFNg */
			  case _SET_HARD_EFFECT:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _HARD_EFFECT_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( 	HARD_EFFECT_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( 	HARD_EFFECT_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			/* GtFNgg` */
			  case _SET_EFFECT_WAVE:
				temp = skipSpace( lptr[line].str );
				param = Asc2Int( temp, &cnt );
				if( cnt != 0 && (0 <= param && param < _EFFECT_WAVE_MAX) ) {
					lptr[line].param = param;
					temp = skipSpace( temp+cnt );
					if( *temp == '=' ) {
						temp++;
						temp = skipSpace( temp );
					}
					if( *temp == '{' ) {
						lptr[line].str = temp;
						status_end_flag = 1;
						while( *temp != '\0' ) {
							if( *temp == '}' ) {
								status_end_flag = 0;
							}
							temp++;
						}
					} else {
						lptr[line].status = 0;
						dispError( 	EFFECT_WAVE_DEFINITION_IS_WRONG, lptr[line].filename, line );
					}
				} else {
					lptr[line].status = 0;
					dispError( 	EFFECT_WAVE_DEFINITION_IS_WRONG, lptr[line].filename, line );
				}
				break;
			/* wb_ */
			  case -1:
				if( (lptr[line-1].status&_SET_EFFECT) != 0 ) {
					lptr[line].status = lptr[line-1].status|_SAME_LINE;
					lptr[line].str = ptr;
				} else {
					/* G[`FbN */
					dispError( COMMAND_NOT_DEFINED, lptr[line].filename, line );
					lptr[line].status = 0;
					lptr[line].str = ptr;
				}
				break;
			}
		}
	}
}



/*--------------------------------------------------------------
	F̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getTone( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		/* Ff[^H */
		if( lptr[line].status == _SET_TONE ) {
			no = lptr[line].param;				/* Fԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			tone_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					tone_tbl[no][i] = 0xffff;
					tone_tbl[no][0]++;
					end_flag = 1;
					line += offset;
					break;
				  case '|':
					tone_tbl[no][i] = 0xfffe;
					tone_tbl[no][0]++;
					i++;
					ptr++;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
						tone_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					//vrc6pɐO(Ȃ)
					//if( cnt != 0 && (0 <= num && num <= 3) ) {
					if( cnt != 0 && (0 <= num && num <= 7) ) {
						tone_tbl[no][i] = num;
						tone_tbl[no][0]++;
						ptr += cnt;
						i++;
					} else {
						dispError( TONE_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
						tone_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
		/* F`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_TONE|_SAME_LINE) ) {
			dispError( TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getTone( lptr[line].inc_ptr );
		}
	}
}



/*--------------------------------------------------------------
	Gx[v̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getEnvelope( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		/* Gx[vf[^H */
		if( lptr[line].status == _SET_ENVELOPE ) {
			no = lptr[line].param;				/* Gx[vԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			envelope_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					envelope_tbl[no][i] = 0xffff;
					envelope_tbl[no][0]++;
					end_flag = 1;
					line += offset;
					break;
				  case '|':
					envelope_tbl[no][i] = 0xfffe;
					envelope_tbl[no][0]++;
					i++;
					ptr++;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
						envelope_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					if( cnt != 0 && (0 <= num && num <= 63) ) {
						envelope_tbl[no][i] = num;
						envelope_tbl[no][0]++;
						ptr += cnt;
						i++;
					} else {
						dispError( ENVELOPE_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
						envelope_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
		/* Gx[v`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_ENVELOPE|_SAME_LINE) ) {
			dispError( ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getEnvelope( lptr[line].inc_ptr );
		}
	}
}

/*--------------------------------------------------------------
	sb`Gx[v̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getPitchEnv( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		/* sb`Gx[vf[^H */
		if( lptr[line].status == _SET_PITCH_ENV ) {
			no = lptr[line].param;				/* sb`Gx[vԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			pitch_env_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					pitch_env_tbl[no][i] = 0xffff;
					pitch_env_tbl[no][0]++;
					end_flag = 1;
					line += offset;
					break;
				  case '|':
					pitch_env_tbl[no][i] = 0xfffe;
					pitch_env_tbl[no][0]++;
					i++;
					ptr++;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( PITCH_ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
						pitch_env_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					if( cnt != 0 && (-127 <= num && num <= 127) ) {
						pitch_env_tbl[no][i] = num;
						pitch_env_tbl[no][0]++;
						ptr += cnt;
						i++;
					} else {
						dispError( PITCH_ENVELOPE_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
						pitch_env_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
		/* sb`Gx[v`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_PITCH_ENV|_SAME_LINE) ) {
			dispError( PITCH_ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getPitchEnv( lptr[line].inc_ptr );
		}
	}
}

/*--------------------------------------------------------------
	sb`W[V̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getPitchMod( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		/* Ff[^H */
		if( lptr[line].status == _SET_PITCH_MOD ) {
			no = lptr[line].param;				/* LFOԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			pitch_mod_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					end_flag = 1;
					line += offset;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( LFO_DEFINITION_IS_WRONG, lptr[line].filename, line );
						pitch_mod_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					if( cnt != 0 ) {
						switch( i ) {
						  case 1:
						  case 2:
						  case 3:
							if( 0 <= num && num <= 255 ) {
								pitch_mod_tbl[no][i] = num;
								pitch_mod_tbl[no][0]++;
								ptr += cnt;
								i++;
							} else {
								dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
								pitch_mod_tbl[no][0] = 0;
								end_flag = 1;
							}
							break;
						  case 4:
							if( 0 <= num && num <= 255 ) {
								pitch_mod_tbl[no][i] = num;
								pitch_mod_tbl[no][0]++;
								ptr += cnt;
								i++;
							} else {
								dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
								pitch_mod_tbl[no][0] = 0;
								end_flag = 1;
							}
							break;
						  default:
							dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
							pitch_mod_tbl[no][0] = 0;
							end_flag = 1;
							break;
						}
					} else {
						dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
						pitch_mod_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
		/* F`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_PITCH_MOD|_SAME_LINE) ) {
			dispError( LFO_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getPitchMod( lptr[line].inc_ptr );
		}
	}
}



/*--------------------------------------------------------------
	m[gGx[v̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getArpeggio( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		/* AyWIf[^H */
		if( lptr[line].status == _SET_ARPEGGIO ) {
			no = lptr[line].param;				/* Gx[vԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			arpeggio_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					arpeggio_tbl[no][i] = 0xffff;
					arpeggio_tbl[no][0]++;
					end_flag = 1;
					line += offset;
					break;
				  case '|':
					arpeggio_tbl[no][i] = 0xfffe;
					arpeggio_tbl[no][0]++;
					i++;
					ptr++;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( NOTE_ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
						arpeggio_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					if( cnt != 0 ) {
						if( num >= 0 ) {
							arpeggio_tbl[no][i] = num;
						} else {
							arpeggio_tbl[no][i] = (-num)|0x80;
						}	
						arpeggio_tbl[no][0]++;
						ptr += cnt;
						i++;
					} else {
						dispError( NOTE_ENVELOPE_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
						arpeggio_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
		/* AyWI`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_ARPEGGIO|_SAME_LINE) ) {
			dispError( NOTE_ENVELOPE_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getArpeggio( lptr[line].inc_ptr );
		}
	}
}



/*--------------------------------------------------------------
	DPCM̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getDPCM( LINE *lptr )
{
	int		line, i, no, offset, end_flag, num, cnt;
	char	*ptr;
	FILE	*fp;
	DPCMTBL	*tbl;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		// DPCMf[^H
		if( lptr[line].status == _SET_DPCM_DATA ) {
			no = lptr[line].param;				// DPCMԍ擾
			ptr = lptr[line].str;
			ptr++;								// '{'̕΂
			tbl = &dpcm_tbl[no];
			tbl->flag = 1;						// tOgp
			tbl->index = -1;
			tbl->fname = NULL;
			tbl->freq = 0;
			tbl->size = 0;
			offset = 0;
			i = 0;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				// f[^I
				  case '}':
					switch( i ) {
					  case 0:
					  case 1:
						dispError( DPCM_PARAMETER_IS_LACKING, lptr[line].filename, line );
						tbl->flag = 0;
						break;
					  case 2:
					  case 3:
						line += offset;
						break;
					}
					end_flag = 1;
					break;
				// s
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( DPCM_DEFINITION_IS_WRONG, lptr[line].filename, line );
						tbl->flag = 0;
						end_flag = 1;
					}
					break;
				  default:
					switch( i ) {
					// t@Co^
					  case 0:
						// t@C"..."ň͂܂ĂH
						if( *ptr == '\"' ) {
							ptr++;
							ptr = skipSpace( ptr );
							tbl->fname = ptr;
							while( *ptr != '\"' && *ptr != '\0' ) {
								ptr++;
							}
						} else {
							tbl->fname = ptr;
							while( *ptr != ' ' && *ptr != '\t' && *ptr != '\0' ) {
								ptr++;
							}
						}
						*ptr = '\0';
						ptr++;
						// t@C݃`FbN/TCY`FbN
						if( (fp = fopen( tbl->fname, "rb" )) == NULL ) {
							dispError( DPCM_FILE_NOT_FOUND, lptr[line+offset].filename, line );
							tbl->flag = 0;
							end_flag = 1;
						} else {
							fseek( fp, 0, SEEK_END );
							tbl->size = ftell( fp );
							fseek( fp, 0, SEEK_SET );
							fclose( fp );
						}
						i++;
						break;
					// Đgo^
					  case 1:
						num = Asc2Int( ptr, &cnt );
						if( cnt != 0 && (0 <= num && num <= 15) ) {
								tbl->freq = num;
						} else {
							dispError( DPCM_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
							tbl->flag = 0;
							end_flag = 1;
						}
						ptr += cnt;
						i++;
						break;
					// ĐTCYo^
					  case 2:
						num = Asc2Int( ptr, &cnt );
						if( cnt != 0 && (0 < num && num < 16384) ) {
							tbl->size = num;
						} else {
							dispError( DPCM_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
							tbl->flag = 0;
							end_flag = 1;
						}
						ptr += cnt;
						i++;
						break;
					  default:
						dispError( DPCM_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
						tbl->flag = 0;
						end_flag = 1;
						break;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
			if( tbl->size > (0xff)*16+1 ) {
				dispError( DPCM_FILE_SIZE_OVER, lptr[line+offset].filename, line );
				tbl->flag = 0;
			}
		// DPCM`_SAME_LINE̎̓G[
		} else if( lptr[line].status == (_SET_DPCM_DATA|_SAME_LINE) ) {
			dispError( DPCM_DEFINITION_IS_WRONG, lptr[line].filename, line );
		// CN[ht@C
		} else if( lptr[line].status == _INCLUDE ) {
			getDPCM( lptr[line].inc_ptr );
		}
	}
}



/*--------------------------------------------------------------
	FMF̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getFMTone( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		/* Ff[^H */
		if( lptr[line].status == _SET_FM_TONE ) {
			no = lptr[line].param;				/* Fԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			fm_tone_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					end_flag = 1;
					line += offset;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line+offset );
						fm_tone_tbl[no][0] = 0;
						line += offset;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					if( cnt != 0 && (0 <= num && num <= 0x3f) ) {
						fm_tone_tbl[no][i] = num;
						fm_tone_tbl[no][0]++;
						ptr += cnt;
						i++;
						if( i > 65 ) {
							dispError( ABNORMAL_PARAMETERS_OF_FM_TONE, lptr[line+offset].filename, line+offset );
							fm_tone_tbl[no][0] = 0;
							line += offset;
							end_flag = 1;
						}
					} else {
						dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line+offset].filename, line+offset );
						fm_tone_tbl[no][0] = 0;
						line += offset;
						end_flag = 1;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
		/* F`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_FM_TONE|_SAME_LINE) ) {
			dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getFMTone( lptr[line].inc_ptr );
		}
	}
}


/*--------------------------------------------------------------
	VRC7F̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getVRC7Tone( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		/* Ff[^H */
		if( lptr[line].status == _SET_VRC7_TONE ) {
			no = lptr[line].param;				/* Fԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			vrc7_tone_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					end_flag = 1;
					line += offset;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line+offset );
						vrc7_tone_tbl[no][0] = 0;
						line += offset;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					if( cnt != 0 && (0 <= num && num <= 0xff) ) {
						vrc7_tone_tbl[no][i] = num;
						vrc7_tone_tbl[no][0]++;
						ptr += cnt;
						i++;
						if( i > 9 ) {
							dispError( ABNORMAL_PARAMETERS_OF_FM_TONE, lptr[line+offset].filename, line+offset );
							vrc7_tone_tbl[no][0] = 0;
							line += offset;
							end_flag = 1;
						}
					} else {
						dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line+offset].filename, line+offset );
						vrc7_tone_tbl[no][0] = 0;
						line += offset;
						end_flag = 1;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
			if( i != 9 ) {
				if (!error_flag) {
					dispError( ABNORMAL_PARAMETERS_OF_FM_TONE, lptr[line].filename, line);
					vrc7_tone_tbl[no][0] = 0;
				}
			}


		/* F`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_VRC7_TONE|_SAME_LINE) ) {
			dispError( FM_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getVRC7Tone( lptr[line].inc_ptr );
		}
	}
}



/*--------------------------------------------------------------
	namco106F̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getN106Tone( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;
					//	   16 14 12 10  8  6  4  2 			
	int	n106_tone_max[] = { 4, 4, 5, 6, 8,10,16,32 }; 
	int	n106_tone_num;

	cnt = 0;
	for( line = 1; line <= lptr->line; line++ ) {
		/* Ff[^H */
		if( lptr[line].status == _SET_N106_TONE ) {
			no = lptr[line].param;				/* Fԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			n106_tone_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					end_flag = 1;
					line += offset;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( N106_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line+offset );
						n106_tone_tbl[no][0] = 0;
						line += offset;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					if( i == 1 ) {						// o^obt@(0`5)			
						if( cnt != 0 && (0 <= num && num <= 32) ) {
							n106_tone_tbl[no][1] = num;
							n106_tone_tbl[no][0]++;
							ptr += cnt;
							i++;
						} else {
							dispError( N106_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line+offset );
							n106_tone_tbl[no][0] = 0;
							line += offset;
							end_flag = 1;
						}
					} else {
						if( cnt != 0 && (0 <= num && num <= 15) ) {
							n106_tone_tbl[no][i] = num;
							n106_tone_tbl[no][0]++;
							ptr += cnt;
							i++;
							if( i > 2+32 ) {
								dispError( ABNORMAL_PARAMETERS_OF_N106_TONE, lptr[line+offset].filename, line+offset );
								n106_tone_tbl[no][0] = 0;
								line += offset;
								end_flag = 1;
							}
						} else {
							dispError( N106_TONE_DEFINITION_IS_WRONG, lptr[line+offset].filename, line+offset );
							n106_tone_tbl[no][0] = 0;
							line += offset;
							end_flag = 1;
						}
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
			switch( n106_tone_tbl[no][0] ) {
			  case 16*2+1: n106_tone_num =  0; break;
			  case 14*2+1: n106_tone_num =  1; break;
			  case 12*2+1: n106_tone_num =  2; break;
			  case 10*2+1: n106_tone_num =  3; break;
			  case  8*2+1: n106_tone_num =  4; break;
			  case  6*2+1: n106_tone_num =  5; break;
			  case  4*2+1: n106_tone_num =  6; break;
			  case  2*2+1: n106_tone_num =  7; break;
			  default:     n106_tone_num = -1; break;
			}
			if( n106_tone_num == -1 ) {
				dispError( ABNORMAL_PARAMETERS_OF_N106_TONE, lptr[line].filename, line );
				n106_tone_tbl[no][0] = 0;
			}
			if( n106_tone_tbl[no][1] >= n106_tone_max[n106_tone_num] ) {
				dispError( N106_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
				n106_tone_tbl[no][0] = 0;
			}
		/* F`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_N106_TONE|_SAME_LINE) ) {
			dispError( N106_TONE_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getN106Tone( lptr[line].inc_ptr );
		}
	}
}



/*--------------------------------------------------------------
	n[hEFAGtFNg̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getHardEffect( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		/* Ff[^H */
		if( lptr[line].status == _SET_HARD_EFFECT ) {
			no = lptr[line].param;				/* GtFNgԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			hard_effect_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					end_flag = 1;
					line += offset;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( LFO_DEFINITION_IS_WRONG, lptr[line].filename, line );
						hard_effect_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					if( cnt != 0 ) {
						switch( i ) {
						  case 1:
							if( 0 <= num && num <= 255 ) {
								hard_effect_tbl[no][i] = num;
								hard_effect_tbl[no][0]++;
								ptr += cnt;
								i++;
							} else {
								dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
								hard_effect_tbl[no][0] = 0;
								end_flag = 1;
							}
							break;
						  case 2:
							if( 0 <= num && num <= 4095 ) {
								hard_effect_tbl[no][i] = num;
								hard_effect_tbl[no][0]++;
								ptr += cnt;
								i++;
							} else {
								dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
								hard_effect_tbl[no][0] = 0;
								end_flag = 1;
							}
							break;
						  case 3:
							if( 0 <= num && num <= 255 ) {
								hard_effect_tbl[no][i] = num;
								hard_effect_tbl[no][0]++;
								ptr += cnt;
								i++;
							} else {
								dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
								hard_effect_tbl[no][0] = 0;
								end_flag = 1;
							}
							break;
						  case 4:
							if( 0 <= num && num <= 7 ) {
								hard_effect_tbl[no][i] = num;
								hard_effect_tbl[no][0]++;
								ptr += cnt;
								i++;
							} else {
								dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
								hard_effect_tbl[no][0] = 0;
								end_flag = 1;
							}
							break;
						  default:
							dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
							hard_effect_tbl[no][0] = 0;
							end_flag = 1;
							break;
						}
					} else {
						dispError( LFO_DEFINITION_IS_WRONG, lptr[line+offset].filename, line );
						hard_effect_tbl[no][0] = 0;
						end_flag = 1;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
		/* F`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_HARD_EFFECT|_SAME_LINE) ) {
			dispError( LFO_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getHardEffect( lptr[line].inc_ptr );
		}
	}
}



/*--------------------------------------------------------------
	GtFNgg`̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getEffectWave( LINE *lptr )
{
	int		line, i, no, end_flag, offset, num, cnt;
	char	*ptr;

	cnt = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		/* Ff[^H */
		if( lptr[line].status == _SET_EFFECT_WAVE ) {
			no = lptr[line].param;				/* g`ԍ擾 */
			ptr = lptr[line].str;
			ptr++;								/* '{'̕΂ */
			effect_wave_tbl[no][0] = 0;
			offset = 0;
			i = 1;
			end_flag = 0;
			while( end_flag == 0 ) {
				ptr = skipSpace( ptr );
				switch( *ptr ) {
				  case '}':
					end_flag = 1;
					line += offset;
					break;
				  case '\0':
					offset++;
					if( line+offset <= lptr->line ) {
						if( (lptr[line+offset].status&_SAME_LINE) == _SAME_LINE ) {
							ptr = lptr[line+offset].str;
						}
					} else {
						dispError( EFFECT_WAVE_DEFINITION_IS_WRONG, lptr[line].filename, line+offset );
						effect_wave_tbl[no][0] = 0;
						line += offset;
						end_flag = 1;
					}
					break;
				  default:
					num = Asc2Int( ptr, &cnt );
					if( cnt != 0 && (0 <= num && num <= 7) ) {
						effect_wave_tbl[no][i] = num;
						effect_wave_tbl[no][0]++;
						ptr += cnt;
						i++;
						if( i > 33 ) {
							dispError( EFFECT_WAVE_DEFINITION_IS_WRONG, lptr[line+offset].filename, line+offset );
							effect_wave_tbl[no][0] = 0;
							line += offset;
							end_flag = 1;
						}
					} else {
						dispError( EFFECT_WAVE_DEFINITION_IS_WRONG, lptr[line+offset].filename, line+offset );
						effect_wave_tbl[no][0] = 0;
						line += offset;
						end_flag = 1;
					}
					break;
				}
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
				}
			}
		/* F`_SAME_LINE̎̓G[ */
		} else if( lptr[line].status == (_SET_EFFECT_WAVE|_SAME_LINE) ) {
			dispError( EFFECT_WAVE_DEFINITION_IS_WRONG, lptr[line].filename, line );
		/* CN[ht@C */
		} else if( lptr[line].status == _INCLUDE ) {
			getEffectWave( lptr[line].inc_ptr );
		}
	}
}



/*--------------------------------------------------------------
	DPCMf[^̃_u폜
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void sortDPCM( DPCMTBL dpcm_tbl[_DPCM_MAX] )
{
	int	i, j;

	for( i = 0; i < _DPCM_MAX; i++ ) {
		if( dpcm_tbl[i].flag == 0 || dpcm_tbl[i].index != -1 ) continue;
		for( j = 0; j < _DPCM_MAX; j++ ) {
			if( i == j ) continue;
			if( dpcm_tbl[j].flag == 0 ) continue;
			// t@CH
			if( strcmp( dpcm_tbl[i].fname, dpcm_tbl[j].fname ) == 0
			 && dpcm_tbl[i].size >= dpcm_tbl[j].size ) {
				dpcm_tbl[j].index = i;
			}
		}
	}
}



/*--------------------------------------------------------------
	DPCMTCYC(16byteoE_ɏC)
 Input:
	
 Output:

--------------------------------------------------------------*/
void checkDPCMSize( DPCMTBL dpcm_tbl[_DPCM_MAX] )
{
	int	i;
	int	adr = 0;

	for( i = 0; i < _DPCM_MAX; i++ ) {
		if( dpcm_tbl[i].flag != 0 ) {
			dpcm_tbl[i].size = (dpcm_tbl[i].size+0x0f)&~0x0f;
			// X^[gAhXݒ
			if( dpcm_tbl[i].index == -1 ) {
				dpcm_tbl[i].start_adr = adr;
				adr += (dpcm_tbl[i].size+63)&~63;
			}
		}
	}
}



/*--------------------------------------------------------------
	DPCMg[^TCY`FbN
 Input:
	
 Output:
	int	: ԑ傫Fԍ
--------------------------------------------------------------*/
int getDPCMTotalSize( DPCMTBL dpcm_tbl[_DPCM_MAX] )
{
	int	i, size = 0;

	for( i = 0; i < _DPCM_MAX; i++ ) {
		if( dpcm_tbl[i].flag != 0 && dpcm_tbl[i].index == -1 ) {
			size += (dpcm_tbl[i].size+63)&~63;	// TvX^[g64byteP
		}
	}
	return size;
}



/*--------------------------------------------------------------
	DPCMf[^ǂݍ
 Input:
	
 Output:
	int	: ԑ傫Fԍ
--------------------------------------------------------------*/
void readDPCM( DPCMTBL dpcm_tbl[_DPCM_MAX] )
{
	int	i;
	FILE	*fp;

	for( i = 0; i < _DPCM_TOTAL_SIZE; i++ ) {
		dpcm_data[i] = 0xaa; 
	}

	for( i = 0; i < _DPCM_MAX; i++ ) {
		if( dpcm_tbl[i].flag != 0 && dpcm_tbl[i].index == -1 ) {
			fp = fopen( dpcm_tbl[i].fname, "rb" );
			if( fp == NULL ) {
//				disperror( DPCM_FILE_NOT_FOUND, 0 );
			} else {
				fread( &dpcm_data[dpcm_tbl[i].start_adr], 1, dpcm_tbl[i].size, fp );
				fclose( fp );
			}
		}
	}
#if DEBUG
	for( i = 0; i < _DPCM_TOTAL_SIZE; i++ ) {
		if( (i&0x0f) != 0x0f ) {
			printf( "%02x,", dpcm_data[i] );
		} else {
			printf( "%02x\n", dpcm_data[i] );
		}
	}
#endif
}



/*--------------------------------------------------------------
	F/Gx[ṽ[v`FbN
 Input:
	
 Output:
	int	: ԑ傫Fԍ
--------------------------------------------------------------*/
int checkLoop( int ptr[128][1024], int max )
{
	int		i, j, lp_flag, ret;

	ret = 0;

	for( i = 0; i < max; i++ ) {
		if( ptr[i][0] != 0 ) {
			lp_flag = 0;
			for( j = 1; j <= ptr[i][0]; j++ ) {
				if( ptr[i][j] == 0xfffe ) lp_flag = 1;
			}
			if( lp_flag == 0 ) {
				j = ptr[i][0];
				ptr[i][j+1] = ptr[i][j  ]; 
				ptr[i][j  ] = ptr[i][j-1]; 
				ptr[i][j-1] = 0xfffe;
				ptr[i][0]++;
			}
			ret = i+1;
		}
	}
	return ret;
}



/*--------------------------------------------------------------
	F̎gpԂ
 Input:
	
 Output:
	int	: ԑ傫Fԍ
--------------------------------------------------------------*/
int getMaxTone( int ptr[128][66], int max )
{
	int		i, ret;

	ret = 0;

	for( i = 0; i < max; i++ ) {
		if( ptr[i][0] != 0 ) {
			ret = i+1;
		}
	}
	return ret;
}



/*--------------------------------------------------------------
	LFO̎gpԂ
 Input:
	
 Output:
	int	: ԑ傫LFOԍ
--------------------------------------------------------------*/
int getMaxLFO( int ptr[_PITCH_MOD_MAX][5], int max )
{
	int		i, ret;

	ret = 0;
	for( i = 0; i < max; i++ ) {
		if( ptr[i][0] != 0 ) {
			ret = i+1;
		}
	}
	return ret;
}



/*--------------------------------------------------------------
	DPCM̎gpԂ
 Input:
	
 Output:
	int	: ԑ傫Fԍ
--------------------------------------------------------------*/
int getMaxDPCM( DPCMTBL	dpcm_tbl[_DPCM_MAX] )
{
	int		i, ret = 0;

	for( i = 0; i < _DPCM_MAX; i++ ) {
		if( dpcm_tbl[i].flag != 0 ) {
			ret = i+1;
		}
	}
	return ret;
}



/*--------------------------------------------------------------
	n[hEFAGtFNg̎gpԂ
 Input:
	
 Output:
	int	: ԑ傫Fԍ
--------------------------------------------------------------*/
int getMaxHardEffect( int ptr[_HARD_EFFECT_MAX][5], int max )
{
	int		i, ret;

	ret = 0;

	for( i = 0; i < max; i++ ) {
		if( ptr[i][0] != 0 ) {
			ret = i+1;
		}
	}
	return ret;
}



/*--------------------------------------------------------------
	GtFNgg`̎gpԂ
 Input:
	
 Output:
	int	: ԑ傫Fԍ
--------------------------------------------------------------*/
int getMaxEffectWave( int ptr[_EFFECT_WAVE_MAX][33], int max )
{
	int		i, ret;

	ret = 0;

	for( i = 0; i < max; i++ ) {
		if( ptr[i][0] != 0 ) {
			ret = i+1;
		}
	}
	return ret;
}



/*--------------------------------------------------------------
	F/Gx[v̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void writeTone( FILE *fp, int tbl[128][1024], char *str, int max )
{
	int		i, j, x;

	fprintf( fp, "%s_table:\n", str );
	if( max != 0 ) {
		for( i = 0; i < max; i++ ) {
			if( tbl[i][0] != 0 ) {
				fprintf( fp, "\tdw\t%s_%03d\n", str, i );
			} else {
				fprintf( fp, "\tdw\t0\n" );
			}			
		}
	}
	fprintf( fp, "%s_lp_table:\n", str );
	if( max != 0 ) {
		for( i = 0; i < max; i++ ) {
			if( tbl[i][0] != 0 ) {
				fprintf( fp, "\tdw\t%s_lp_%03d\n", str, i );
			} else {
				fprintf( fp, "\tdw\t0\n" );
			}			
		}

		for( i = 0; i < max; i++ ) {
			if( tbl[i][0] != 0 ) {
				fprintf( fp, "\n%s_%03d:\n", str, i );
				x = 0;
				for( j = 1; j <= tbl[i][0]; j++ ) {
					if( tbl[i][j] == 0xfffe ) {
						if( x != 0 ) fprintf( fp, "\n" );
						fprintf( fp, "%s_lp_%03d:\n", str, i );
						x = 0;
					} else if( x == 0 ) {
						fprintf( fp, "\tdb\t$%02x", tbl[i][j]&0xff );
						x++;
					} else if( x == 7 ) {
						fprintf( fp, ",$%02x\n", tbl[i][j]&0xff );
						x = 0;
					} else {
						fprintf( fp, ",$%02x", tbl[i][j]&0xff );
						x++;
					}
				}
			}
		}
	}
	fprintf( fp, "\n\n" );
}



/*--------------------------------------------------------------
	FMF̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void writeToneFM( FILE *fp, int tbl[_FM_TONE_MAX][66], char *str, int max )
{
	int		i, j, x;

	fprintf( fp, "%s_data_table:\n", str );
	if( max != 0 ) {
		for( i = 0; i < max; i++ ) {
			if( tbl[i][0] != 0 ) {
				fprintf( fp, "\tdw\t%s_%03d\n", str, i );
			} else {
				fprintf( fp, "\tdw\t0\n" );
			}
		}

		for( i = 0; i < max; i++ ) {
			if( tbl[i][0] != 0 ) {
				fprintf( fp, "\n%s_%03d:\n", str, i );
				x = 0;
				for( j = 1; j <= tbl[i][0]; j++ ) {				// tbl[i][0] = f[^[(byte)
					if( x == 0 ) {
						fprintf( fp, "\tdb\t$%02x", tbl[i][j]&0xff );
						x++;
					} else if( x == 7 ) {
						fprintf( fp, ",$%02x\n", tbl[i][j]&0xff );
						x = 0;
					} else {
						fprintf( fp, ",$%02x", tbl[i][j]&0xff );
						x++;
					}
				}
			}
		}
	}
#if 0
	fprintf( fp, "%s_effect_select:\n", str );
	fprintf( fp, "%s_4088_data:\n", str );
	fprintf( fp, "\n\n" );
#endif
}

/*--------------------------------------------------------------
	VRC7F̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void writeToneVRC7( FILE *fp, int tbl[_VRC7_TONE_MAX][66], char *str, int max )
{
	int		i, j, x;

	fprintf( fp, "%s_data_table:\n", str );
	if( max != 0 ) {
		for( i = 0; i < max; i++ ) {
			if( tbl[i][0] != 0 ) {
				fprintf( fp, "\tdw\t%s_%03d\n", str, i );
			} else {
				fprintf( fp, "\tdw\t0\n" );
			}
		}

		for( i = 0; i < max; i++ ) {
			if( tbl[i][0] != 0 ) {
				fprintf( fp, "\n%s_%03d:\n", str, i );
				x = 0;
				for( j = 1; j <= tbl[i][0]; j++ ) {				// tbl[i][0] = f[^[(byte)
					if( x == 0 ) {
						fprintf( fp, "\tdb\t$%02x", tbl[i][j]&0xff );
						x++;
					} else if( x == 7 ) {
						fprintf( fp, ",$%02x\n", tbl[i][j]&0xff );
						x = 0;
					} else {
						fprintf( fp, ",$%02x", tbl[i][j]&0xff );
						x++;
					}
				}
			}
		}
	}

	fprintf( fp, "\n\n" );
}




/*--------------------------------------------------------------
	n[hEFAGtFNg̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void writeHardEffect( FILE *fp, int tbl[_HARD_EFFECT_MAX][5], char *str, int max )
{
	int		i;

	fprintf( fp, "%s_effect_select:\n", str );
	for ( i = 0; i < max; i++ ) {
		fprintf( fp, "\tdb\t$%02x,$84,$%02x,$85,$00,$87,$80,$88\n",
			tbl[i][1], (tbl[i][3] | 0x80) );
		fprintf( fp, "\tdb\t$%02x,$86,$%02x,$87,$%02x,$ff,$00,$00\n",
			tbl[i][4], (tbl[i][2] & 0x00FF), ((tbl[i][2] & 0x0F00)>>8) );
	}
}

/*--------------------------------------------------------------
	GtFNgg`̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void writeEffectWave( FILE *fp, int tbl[_EFFECT_WAVE_MAX][33], char *str, int max )
{
	int		i, j, x;

	fprintf( fp, "%s_4088_data:\n", str );
	for( i = 0; i < max; i++ ) {
		if( tbl[i][0] != 0 ) {
			x = 0;
			for( j = 1; j <= tbl[i][0]; j++ ) {				// tbl[i][0] = f[^[(byte)
				if( x == 0 ) {
					fprintf( fp, "\tdb\t$%02x", tbl[i][j]&0xff );
					x++;
				} else if( x == 7 ) {
					fprintf( fp, ",$%02x\n", tbl[i][j]&0xff );
					x = 0;
				} else {
					fprintf( fp, ",$%02x", tbl[i][j]&0xff );
					x++;
				}
			}
		}
		else
		{
			/* _~[f[^o */
			for (j = 0; j < 4; j++) {
				fprintf( fp, "\tdb\t$00,$00,$00,$00,$00,$00,$00,$00\n");
			}
		}
	}
	
	fprintf( fp, "\n\n" );
}



/*--------------------------------------------------------------
	N106F̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void writeToneN106( FILE *fp, int tbl[_N106_TONE_MAX][2+64], char *str, int max )
{
	int		i, j, x;

	// gp`l
	fprintf( fp, "%s_channel:\n", str );
	fprintf( fp, "\tdb\t%d\n", n106_track_num );
	// p[^
	fprintf( fp, "%s_wave_init:\n", str );
	if( max != 0 ) {
		for( i = 0; i < max; i++ ) {
			switch( tbl[i][0] ) {
			  case  2*2+1: j = 7; x = tbl[i][1]* 2*2; break;
			  case  4*2+1: j = 6; x = tbl[i][1]* 4*2; break;
			  case  6*2+1: j = 5; x = tbl[i][1]* 6*2; break;
			  case  8*2+1: j = 4; x = tbl[i][1]* 8*2; break;
			  case 10*2+1: j = 3; x = tbl[i][1]*10*2; break;
			  case 12*2+1: j = 2; x = tbl[i][1]*12*2; break;
			  case 14*2+1: j = 1; x = tbl[i][1]*14*2; break;
			  case 16*2+1: j = 0; x = tbl[i][1]*16*2; break;
			  default:     j = 0; x = 0; break;	
			}
			fprintf( fp, "\tdb\t$%02x,$%02x\n", j, x );
		}
	}
	// p[^
	fprintf( fp, "%s_wave_table:\n", str );
	if( max != 0 ) {
		for( i = 0; i < max; i++ ) {
			if( tbl[i][0] != 0 ) {
				fprintf( fp, "\tdw\t%s_wave_%03d\n", str, i );
			} else {
				fprintf( fp, "\tdw\t0\n" );
			}
		}
	}			
	if( max != 0 ) {
		for( i = 0; i < max; i++ ) {
			if( tbl[i][0] != 0 ) {
				fprintf( fp, "%s_wave_%03d:\n", str, i );
				fprintf( fp, "\tdb\t" );
				for( j = 0; j < tbl[i][0]/2-1; j++ ) {
					fprintf( fp, "$%02x,", (tbl[i][2+(j*2)+1]<<4)+tbl[i][2+(j*2)+0] );
				}
				fprintf( fp, "$%02x\n", (tbl[i][2+(j*2)+1]<<4)+tbl[i][2+(j*2)+0] );
			}
		}
	}
	fprintf( fp, "\n\n" );
}



/*--------------------------------------------------------------
	DPCMf[^̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void writeDPCM( FILE *fp, DPCMTBL dpcm_tbl[_DPCM_MAX], char *str, int max )
{
	int		i;
	int		freq,adr,size;

	fprintf( fp, "%s:\n", str );
	if( max != 0 ) {
		for( i = 0; i < max; i++ ) {
			if( dpcm_tbl[i].flag != 0 ) {
				freq = dpcm_tbl[i].freq;
				size = dpcm_tbl[i].size/16;
				if( dpcm_tbl[i].index == -1 ) {
					adr  = dpcm_tbl[i].start_adr/64;
				} else {
					adr  = dpcm_tbl[dpcm_tbl[i].index].start_adr/64;
				}
				fprintf( fp, "\tdb\t$%02x,$%02x,$%02x,$%02x\n", freq, 0, adr, size );
			} else {
				fprintf( fp, "\tdb\t$00,$00,$00,$00\n");
			}
		}

		if( dpcm_size != 0 ) {
			fprintf( fp, "\t.bank\t%1d\n", 2 );
			fprintf( fp, "\t.org\t$%04x\n", 0xc000 );

			if( dpcm_size <= 8192 ) {
				for( i = 0; i < dpcm_size; i++ ) {
					if( (i&0x0f) == 0x00 ) {
						fprintf( fp, "\tdb\t$%02x,", dpcm_data[i] );
					}else if( (i&0x0f) != 0x0f ) {
						fprintf( fp, "$%02x,", dpcm_data[i] );
					} else {
						fprintf( fp, "$%02x\n", dpcm_data[i] );
					}
				}
			} else {
				for( i = 0; i < 8192; i++ ) {
					if( (i&0x0f) == 0x00 ) {
						fprintf( fp, "\tdb\t$%02x,", dpcm_data[i] );
					}else if( (i&0x0f) != 0x0f ) {
						fprintf( fp, "$%02x,", dpcm_data[i] );
					} else {
						fprintf( fp, "$%02x\n", dpcm_data[i] );
					}
				}
				fprintf( fp, "\t.bank\t%1d\n", 3 );
				fprintf( fp, "\t.org\t$%04x\n", 0xe000 );
				for( i = 8192; i < dpcm_size; i++ ) {
					if( (i&0x0f) == 0x00 ) {
						fprintf( fp, "\tdb\t$%02x,", dpcm_data[i] );
					}else if( (i&0x0f) != 0x0f ) {
						fprintf( fp, "$%02x,", dpcm_data[i] );
					} else {
						fprintf( fp, "$%02x\n", dpcm_data[i] );
					}
				}
			}	
		}
	}
	fprintf( fp, "\n\n" );
}



/*--------------------------------------------------------------
        lptr  flag ȕ̃|C^Ԃ
--------------------------------------------------------------*/
char *headerStrPointerOfSpecificFlag( LINE *lptr, int flag )
{
	int i;

	for( i = 1; i <= lptr[0].line; i++ ) {
		if( lptr[i].status == flag ) {
			return lptr[i].str;
		} else if( lptr[i].status == _INCLUDE ) {
			headerStrPointerOfSpecificFlag( lptr[i].inc_ptr, flag );
		}
	}
	return (char *)NULL;
}




/*--------------------------------------------------------------
        lptr  flag ȕ max oCg buf  strncpy
--------------------------------------------------------------*/
void writeStringSub( LINE *lptr, char *buf, int max, int flag )
{
	char *p;
	p = headerStrPointerOfSpecificFlag(lptr, flag);
	if (p) {
		strncpy( buf, p, max );
	}
}



/*--------------------------------------------------------------
	łݎ҂̕w|C^Ԃ
 Input:
	
 Output:
	s=NULL
--------------------------------------------------------------*/
char *getProgramer(LINE *lptr )
{
	return	headerStrPointerOfSpecificFlag(lptr, _PROGRAMER);
}


/*--------------------------------------------------------------
	^Cg/Ȏ/[J[/łݎ҂̏擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void getSongInfo(LINE *lptr)
{
	writeStringSub( lptr, song_name, 1023, _TITLE );
	writeStringSub( lptr, composer, 1023, _COMPOSER );
	writeStringSub( lptr, maker, 1023, _MAKER );
}


/*--------------------------------------------------------------
	^Cg/Ȏ/[J[/łݎ҂RgƂď
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void writeSongInfo( FILE *fp, LINE *lptr )
{
	char *p;
	fprintf( fp, "; Title: %s\n", song_name );
	fprintf( fp, "; Composer: %s\n", composer );
	fprintf( fp, "; Maker: %s\n", maker );
	p = getProgramer(lptr);
	if (p) {
		fprintf( fp, "; Programer: %s\n", p);
	}
	fprintf(fp, "\n");
}



/*--------------------------------------------------------------
	
 Input: f[^dbƂmaxoCgo(I[ȍ~0Ŗ߂)
	
 Output:
	
--------------------------------------------------------------*/
void printStrDb( FILE *fp, const char *str, int max)
{
	int i, end_flag = 0, newline_flag = 0;
	char c;
	for (i = 0; i < max; i++) {
		c = *(str + i);
		if (c == '\0') {
			end_flag = 1;
		}
		if (end_flag) {
			c = '\0';
		}
		switch (i % 8) {
			case 0:
				newline_flag = 0;
				fprintf(fp, "\tdb\t$%02x", c & 0xff);
				break;
			case 7:
				newline_flag = 1;
				fprintf(fp, ", $%02x",  c & 0xff);
				break;
			default:				
				fprintf(fp, ", $%02x",  c & 0xff);
				break;
		}
		if (newline_flag) {
			fprintf(fp, "\n");
		}
	}
	if (!newline_flag) {
		fprintf(fp, "\n");
	}
	
}



/*--------------------------------------------------------------
	^Cg/Ȏ/[J[macroƂď
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void writeSongInfoMacro(FILE *fp)
{
	fprintf( fp, "TITLE\t.macro\n");
	printStrDb(fp, song_name, 32);
	fprintf(fp, "\t.endm\n");
	fprintf( fp, "COMPOSER\t.macro\n");
	printStrDb(fp, composer, 32);
	fprintf(fp, "\t.endm\n");
	fprintf( fp, "MAKER\t.macro\n");
	printStrDb(fp, maker, 32);
	fprintf(fp, "\t.endm\n");
}




/*--------------------------------------------------------------
	IN^[uL̔]
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void checkOctaveRev( LINE *lptr )
{
	int i;

	for( i = 1; i <= lptr->line; i++ ) {
		if( lptr[i].status == _OCTAVE_REV ) {
			if( *(lptr[i].str) == '0' ) {
				octave_flag = 0;
			} else {
				octave_flag = 1;
			}
		} else if( lptr[i].status == _INCLUDE ) {
			checkOctaveRev( lptr[i].inc_ptr );
		}
	}
}



/*--------------------------------------------------------------
	p[^n̃R}h̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
char *setCommandBuf( int n, CMD *cmd, int com_no, char *ptr, int line, int enable )
{
	int		cnt, i;
	int		param[PARAM_MAX];

	for( i = 0; i < PARAM_MAX; i++ ) {
		param[i] = 0;
	}

	if( n != 0 ) {
		i = 0;
		if( n > 1 ) {					// n2ȏ̂Ƃ","̏
			for( i = 0; i < n-1; i++ ) {
				cnt = 0;
				param[i] = Asc2Int( ptr, &cnt );
				if( cnt == 0 ) {		/* p[^ꍇ̓G[̏o鐔lɏ */
					param[i] = 0x80000000;
				}
				ptr += cnt;
				ptr = skipSpace( ptr );
				if( *ptr == ',' ) {
					ptr++;
					ptr = skipSpace( ptr );
				}
			}
		}
		cnt = 0;
		param[i] = Asc2Int( ptr, &cnt );
		if( cnt == 0 ) {		/* p[^ꍇ̓G[̏o鐔lɏ */
			param[i] = 0x80000000;
		}
		ptr += cnt;
	}

	if( enable != 0 ) {
		cmd->cnt = 0;
		cmd->line = line;
		cmd->cmd  = com_no;
		cmd->len = 0;
		if( n != 0 ) {
			for( i = 0; i < n; i++ ) {
				cmd->param[i] = param[i];
			}
		}
	}

	return ptr;
}



/*--------------------------------------------------------------
	p[^̎擾
 Input:
	
 Output:
	
--------------------------------------------------------------*/
char *getLength( char *ptr, double *len, double def )
{
	int		cnt;
	double 	temp;

	/* t[w */
	if( *ptr == '#' ) {
		ptr++;
		*len = Asc2Int( ptr, &cnt );
		if( cnt != 0 ) {
			ptr += cnt;
			*len = *len / tbase;
		} else {
			*len = -1;
		}
	/* JEgw */
	} else if( *ptr == '%' ) {
		ptr++;
		*len = Asc2Int( ptr, &cnt );
		if( cnt != 0 ) {
			ptr += cnt;
		} else {
			*len = -1;
		}
	/* yIw */
	} else {
		*len = Asc2Int( ptr, &cnt );
		if( cnt != 0 ) {
			ptr += cnt;
			*len = _BASE/(*len);
		} else {
			/* p[^ꍇ̓G[̏o鐔lɏ */
			*len = def;
		}
		/* G[/lR}h̎͏Ȃ */
		if( *len != -1 ) {
			/* _̏(\) */
			temp = *len;
			while( *ptr == '.' ) {
				temp /= 2;
				*len += temp;
				ptr++;
			}
		}
	}
	return ptr;
}



/*--------------------------------------------------------------
	p[^1()̃R}h̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
char *setCommandBufL( CMD *cmd, int com_no, char *ptr, int line, int enable )
{
	cmd->cnt = 0;
	cmd->line = line;
	cmd->cmd  = com_no;

	ptr = getLength( ptr, &(cmd->len), -1 );
	if( cmd->len != -1 ) {
		if( enable != 0 ) {
			length = cmd->len;
		}
	}

	return ptr;
}



/*--------------------------------------------------------------
	p[^1(K/)̃R}h̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
char *setCommandBufN( CMD *cmd, int com_no, char *ptr, int line, int enable )
{
	int		oct_ofs, note;
	double	len;

	com_no += transpose;

	/* c+-++-++--Ƃo悤ɑ΍(ʂȂ) */
	while( 1 ) {
		if( *ptr == '+' ) {
			com_no++;
			ptr++;
		} else if( *ptr == '-' ) {
			com_no--;
			ptr++;
		} else {
			break;
		}
	}
	/* IN^[u܂̕␳ */
	oct_ofs = 0;
	while( com_no < _NOTE_C ) {
		com_no += 12;
		oct_ofs--;
	}
	while( com_no > _NOTE_B ) {
		com_no -= 12;
		oct_ofs++;
	}

	note = ((octave+oct_ofs)<<4)+com_no;
	/* K͈̔̓`FbN */
	if( note < 0 ) {
		switch( note ) {
		  case -5: note = 15; break;
		  case -6: note = 14; break;
		  case -7: note = 13; break;
		  default: note =  0; break;
		}
	} else if( note > 0x8f ) {
		note = 0x8f;
	}

	ptr = getLength( ptr, &len, length );

	if( enable != 0 ) {
		cmd->cnt  = 0;
		cmd->line = line;
		cmd->cmd  = note;
		cmd->len  = len;
	}

	return ptr;
}



/*--------------------------------------------------------------
	p[^1(K(ڎw)/)̃R}h̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
char *setCommandBufN0( CMD *cmd, char *ptr, int line, int enable )
{
	int		cnt, note;
	double	len;

	cnt  = 0;
	note = Asc2Int( ptr, &cnt );
	if( cnt == 0 ) {
		dispError( ABNORMAL_PITCH_VALUE, cmd->filename, line );
		return ptr+1;
	}
	ptr += cnt;

	// K͈̔̓`FbN
	if( note < 0 ) {
		note = 0;
	} else if( note > 0x8f ) {
		note = 0x8f;
	}

	ptr = skipSpace( ptr );				// ]ȃXy[XXLbv
	// ","Ƃ͉݂
	if( *ptr == ',' ) {
		ptr++;
		ptr = skipSpace( ptr );			// ]ȃXy[XXLbv

		ptr = getLength( ptr, &len, length );
	// ","ȂƂ̓ftHg̉gp
	} else {
		len = length;
	}

	if( enable != 0 ) {
		cmd->cnt  = 0;
		cmd->line = line;
		cmd->cmd  = note;
		cmd->len  = len;
	}

	return ptr;
}



/*--------------------------------------------------------------
	p[^1(g(ڎw)/)̃R}h̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
char *setCommandBufN1( CMD *cmd, int com_no, char *ptr, int line, int enable )
{
	int		cnt, freq;
	double	len;

	cnt = 0;
	freq = Asc2Int( ptr, &cnt );
	// `FbN
	if( cnt == 0 ) {
		dispError( ABNORMAL_PITCH_VALUE, cmd->filename, line );
		return ptr+1;
	}
	ptr += cnt;
	// p[^͈̓`FbN
	if( 0x0008 > freq && freq >= 0x07f2 ) {
		dispError( ABNORMAL_PITCH_VALUE, cmd->filename, line );
		return ptr+1;
	}
	// "," Ƃ͉擾
	ptr = skipSpace( ptr );
	if( *ptr == ',' ) {
		ptr++;
		ptr = skipSpace( ptr );
		ptr = getLength( ptr, &len, length );
	// "," ȂƂ̓ftHg
	} else {
		len = length;
	}

	if( enable != 0 ) {
		cmd->cnt      = 0;
		cmd->line     = line;
		cmd->cmd      = com_no;
		cmd->len      = len;
		cmd->param[0] = freq;
	}

	return ptr;
}



/*--------------------------------------------------------------
	p[^1(x/)̃R}h̏
 Input:
	
 Output:
	
--------------------------------------------------------------*/
char *setCommandBufR( CMD *cmd, int com_no, char *ptr, int line, int enable )
{
	double	len;

	ptr = getLength( ptr, &len, length );

	if( enable != 0 ) {
		cmd->cnt = 0;
		cmd->line = line;
		cmd->cmd = com_no;
		cmd->len = len;
	}

	return ptr;
}



/*--------------------------------------------------------------
	
 Input:
	
 Output:
	
--------------------------------------------------------------*/
CMD * analyzeData( int trk, CMD *cmd, LINE *lptr )
{
	int		i, line, com, cnt;
	char	*ptr;

	typedef struct {
		char	*cmd;
		int		num;
		unsigned long		enable;
	} MML;
	const MML mml[] = {
		{ "c", _NOTE_C,			(ALLTRACK) },
		{ "d", _NOTE_D,			(ALLTRACK) },
		{ "e", _NOTE_E,			(ALLTRACK) },
		{ "f", _NOTE_F,			(ALLTRACK) },
		{ "g", _NOTE_G,			(ALLTRACK) },
		{ "a", _NOTE_A,			(ALLTRACK) },
		{ "b", _NOTE_B,			(ALLTRACK) },
		{ "@n", _KEY,			(TRACK(0)|TRACK(1)|TRACK(2)|FMTRACK) },
		{ "n", _NOTE,			(ALLTRACK) },
		{ "w", _WAIT,			(ALLTRACK) },
		{ "@t", _TEMPO2,		(ALLTRACK) },
		{ "t", _TEMPO,			(ALLTRACK) },
		{ "o", _OCTAVE,			(ALLTRACK) },
		{ ">", _OCT_UP,			(ALLTRACK) },
		{ "<", _OCT_DW,			(ALLTRACK) },
		{ "l", _LENGTH,			(ALLTRACK) },
		{ "v+", _VOL_PLUS,		(ALLTRACK&~DPCMTRACK) },
		{ "v-", _VOL_MINUS,		(ALLTRACK&~DPCMTRACK) },
		{ "v", _VOLUME,			(ALLTRACK&~DPCMTRACK) },
		{ "NB", _NEW_BANK,		(ALLTRACK) },
		{ "EPOF", _EP_OFF,		(ALLTRACK&~DPCMTRACK) },
		{ "EP",   _EP_ON,		(ALLTRACK&~DPCMTRACK) },
		{ "ENOF", _EN_OFF,		(ALLTRACK&~DPCMTRACK) },
		{ "EN",   _EN_ON,		(ALLTRACK&~DPCMTRACK) },
		{ "MPOF", _LFO_OFF,		(ALLTRACK&~DPCMTRACK) },
		{ "MP",   _LFO_ON,		(ALLTRACK&~DPCMTRACK) },
		{ "EH",	_HARD_ENVELOPE,		(FMTRACK) },
		{ "MHOF", _MH_OFF,		(FMTRACK) },
		{ "MH",	  _MH_ON,		(FMTRACK) },
		{ "D", _DETUNE,			(ALLTRACK&~NOISETRACK&~DPCMTRACK) },
		{ "K", _TRANSPOSE,		(ALLTRACK&~NOISETRACK&~DPCMTRACK) },
		{ "@q", _QUONTIZE2,		(ALLTRACK) },
		{ "@vr", _REL_ENV,		(ALLTRACK&~TRACK(2)&~DPCMTRACK) }, 
		{ "@v", _ENVELOPE,		(ALLTRACK&~TRACK(2)&~DPCMTRACK) },
		{ "@@", _ORG_TONE,		(TRACK(0)|TRACK(1)|FMTRACK|VRC7TRACK|VRC6PLSTRACK|N106TRACK|MMC5PLSTRACK) },
		{ "@", _TONE,			(TRACK(0)|TRACK(1)|VRC6PLSTRACK|MMC5PLSTRACK) },
		{ "s", _SWEEP,			(TRACK(0)|TRACK(1)|FMTRACK) },
		{ "&", _SLAR,			(ALLTRACK) },
		{ "y", _DATA_WRITE,		(ALLTRACK) },
		{ "x", _DATA_THRUE,		(ALLTRACK) },

		{ "|:", _REPEAT_ST2,		(ALLTRACK) },
		{ ":|", _REPEAT_END2,		(ALLTRACK) },
		{ "\\", _REPEAT_ESC2,		(ALLTRACK) },

		{ "L", _SONG_LOOP,		(ALLTRACK) },
		{ "[", _REPEAT_ST,		(ALLTRACK) },
		{ "]", _REPEAT_END,		(ALLTRACK) },
		{ "|", _REPEAT_ESC,		(ALLTRACK) },
		{ "{", _CONT_NOTE,		(ALLTRACK) },
		{ "}", _CONT_END,		(ALLTRACK) },
		{ "q", _QUONTIZE,		(ALLTRACK) },
		{ "r", _REST,			(ALLTRACK) },
		{ "^", _TIE,			(ALLTRACK) },
		{ "!", _DATA_BREAK,		(ALLTRACK) },
		{ "",  _TRACK_END,		(ALLTRACK) },
	};

	cnt = 0;

	transpose = 0;

	for( line = 1; line <= lptr->line; line++ ) {
		if( (lptr[line].status == _TRACK) && ((lptr[line].param&(1<<trk)) != 0) ) {
			ptr = lptr[line].str;
			while( *ptr != '\0' ) {
				ptr = skipSpace( ptr );			// ]ȃXy[XXLbv
				if( *ptr == '\0' ) break;		// ̃C͏IH
				// R}h
				for( i = 0; mml[i].num != _TRACK_END; i++ ) {
					if( strncmp( mml[i].cmd, ptr, strlen(mml[i].cmd) ) == 0 ) break;
				}
				ptr += strlen(mml[i].cmd);		// R}h̕XLbv
				cmd->filename = lptr[line].filename;	// G[õ͎t@C擾
				switch( mml[i].num ) {
				/* IN^[u */
				  case _OCTAVE:
					com = Asc2Int( ptr, &cnt );
					if( cnt != 0 ) {
						// R}h͗L̎͏o^
						if( (mml[i].enable&(1<<trk)) != 0 ) {
							if( trk == BTRACK(0) || trk == BTRACK(1) || trk == BTRACK(2) ) {
								octave = com-2;
							} else {
								octave = com;
							}
						}
						ptr += cnt;
					}
					break;
				/* IN^[uAbv */
				  case _OCT_UP:
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( octave_flag == 0 ) { octave++; } else { octave--; }
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				/* IN^[u_E */
				  case _OCT_DW:
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( octave_flag == 0 ) { octave--; } else { octave++; }
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				/* ݒ */
				  case _LENGTH:
					ptr = setCommandBufL( cmd, _LENGTH, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				/* (nR}h) */
				  case _NOTE:
					ptr = setCommandBufN0( cmd, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				/* (@nR}h) */
				  case _KEY:
					ptr = setCommandBufN1( cmd, _KEY, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				/*  */
				  case _NOTE_C:
				  case _NOTE_D:
				  case _NOTE_E:
				  case _NOTE_F:
				  case _NOTE_G:
				  case _NOTE_A:
				  case _NOTE_B:
					ptr = setCommandBufN( cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				/* x/A */
				  case _REST:
				  case _CONT_END:
				  case _TIE:
				  case _WAIT:
					ptr = setCommandBufR( cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				/* R}hp[^0̕ */
				  case _SLAR:			/* X[ */
				  case _SONG_LOOP:			/* ȃ[v */
				  case _REPEAT_ST:		/* s[g(ł͓WJ) */
				  case _REPEAT_ESC:		/* s[gr */
				  case _CONT_NOTE:		/* AJn */
				  case _LFO_OFF:
				  case _EP_OFF:
				  case _EN_OFF:
				  case _MH_OFF:
				  case _REPEAT_ST2:		/* s[g2 */
				  case _REPEAT_ESC2:	/* s[gr2 */
					setCommandBuf( 0, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;					
				/* R}hp[^1̕ */
				  case _TEMPO:			/* e| */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( cmd->param[0] < 0 ) {
							dispError( ABNORMAL_TEMPO_VALUE, lptr[line].filename, line );
							cmd->cmd = _NOP;
						} else {
							tbase = (double)_BASETEMPO/(double)cmd->param[0];
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _TONE:			/* F؂ւ */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						//vrc6pɐO(Ȃ)
						//if( cmd->param[0] < 0 || cmd->param[0] > 7 ) {
						if( cmd->param[0] < 0 || cmd->param[0] > 15 ) {
							dispError( ABNORMAL_TONE_NUMBER, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _ORG_TONE:		/* F؂ւ */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( cmd->param[0] < 0 || cmd->param[0] > 127 ) {
							dispError( ABNORMAL_TONE_NUMBER, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _ENVELOPE:		/* Gx[vw */
					cmd->filename = lptr[line].filename;
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( cmd->param[0] == 255) { 
							volume_flag = 0x0000; 
						} else if( (trk != BFMTRACK && (0 <= cmd->param[0] && cmd->param[0] <= 127)) 
							|| (trk == BFMTRACK && (0 <= cmd->param[0] && cmd->param[0] <=  63)) ) {
							volume_flag = 0x8000; 
						} else {
							dispError( ABNORMAL_ENVELOPE_NUMBER, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						} 
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line ); 
					} 
					break; 
				  case _REL_ENV:		/* [XGx[vw */ 
					cmd->filename = lptr[line].filename; 
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) ); 
					if( (mml[i].enable&(1<<trk)) != 0 ) { 
						if( cmd->param[0] == 255 ) { 
							volume_flag = 0x0000; 
						} else if( (trk != BFMTRACK && (0 <= cmd->param[0] && cmd->param[0] <= 127)) 
							|| (trk == BFMTRACK && (0 <= cmd->param[0] && cmd->param[0] <=  63)) ) {
							volume_flag = 0x8000;
						} else {
							dispError( ABNORMAL_ENVELOPE_NUMBER, lptr[line].filename, line ); 
							cmd->cmd = 0; 
							cmd->line = 0; 
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _VOL_PLUS:		/* ʎw */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( cmd->param[0] == 0x80000000 ) {
							cmd->param[0] = 1;
						}
						if( ((1<<trk) & ~(FMTRACK|VRC6SAWTRACK) && 0 <= volume_flag && volume_flag <= 15)
						 || ((1<<trk) & (FMTRACK|VRC6SAWTRACK) && 0 <= volume_flag && volume_flag <= 63) ) {
							cmd->cmd = _VOLUME;
							cmd->param[0] = volume_flag+cmd->param[0];
							if( ((1<<trk) & ~(FMTRACK|VRC6SAWTRACK) && (cmd->param[0] < 0 || cmd->param[0] > 15))
							 || ((1<<trk) & (FMTRACK|VRC6SAWTRACK) && (cmd->param[0] < 0 || cmd->param[0] > 63)) ) {
								dispError( VOLUME_RANGE_OVER_OF_RELATIVE_VOLUME, lptr[line].filename, line );
								cmd->cmd = 0;
								cmd->line = 0;
							} else {
								volume_flag = cmd->param[0];
							}
						} else {
							dispError( RELATIVE_VOLUME_WAS_USED_WITHOUT_SPECIFYING_VOLUME, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _VOL_MINUS:		/* ʎw */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( cmd->param[0] == 0x80000000 ) {
							cmd->param[0] = 1;
						}
						if( ((1<<trk) & ~(FMTRACK|VRC6SAWTRACK) && 0 <= volume_flag && volume_flag <= 15)
						 || ((1<<trk) & (FMTRACK|VRC6SAWTRACK) && 0 <= volume_flag && volume_flag <= 63) ) {
							cmd->cmd = _VOLUME;
							cmd->param[0] = volume_flag-cmd->param[0];
							if( cmd->param[0] < 0 ) {
								dispError( VOLUME_RANGE_UNDER_OF_RELATIVE_VOLUME, lptr[line].filename, line );
								cmd->cmd = 0;
								cmd->line = 0;
							} else {
								volume_flag = cmd->param[0];
							}
						} else {
							dispError( RELATIVE_VOLUME_WAS_USED_WITHOUT_SPECIFYING_VOLUME, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _VOLUME:			/* ʎw */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( ((1<<trk) & ~(FMTRACK|VRC6SAWTRACK) && (cmd->param[0] < 0 || cmd->param[0] > 15))
						 || ((1<<trk) & (FMTRACK|VRC6SAWTRACK) && (cmd->param[0] < 0 || cmd->param[0] > 63)) ) {
							dispError( ABNORMAL_VOLUME_VALUE, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						} else {
							volume_flag = cmd->param[0];
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _HARD_ENVELOPE:
					ptr = setCommandBuf( 2, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( (cmd->param[0] < 0 || cmd->param[0] >  1)
						 && (cmd->param[1] < 0 || cmd->param[1] > 63) ) {
							dispError( ABNORMAL_ENVELOPE_VALUE, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						} else {
							volume_flag = 0x8000;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _QUONTIZE:		/* NI^CY(length*n/8) */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( cmd->param[0] < 1 || cmd->param[0] > 8 ) {
							dispError( ABNORMAL_QUANTIZE_VALUE,  lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _QUONTIZE2:		/* NI^CY(length-n) */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _LFO_ON:			/* \tgken */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( (cmd->param[0] != 255) 
						 && (cmd->param[0] < 0 || cmd->param[0] > 63) ) { 
							dispError( ABNORMAL_LFO_NUMBER, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _EP_ON:			/* sb`Gx[v */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( (cmd->param[0] != 255) 
						 && (cmd->param[0] < 0 || cmd->param[0] > 127) ) { 
							dispError( ABNORMAL_PITCH_ENVELOPE_NUMBER, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _EN_ON:			/* m[gGx[v */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( (cmd->param[0] != 255)
						 && (cmd->param[0] < 0 || cmd->param[0] > 127) ) { 
							dispError( ABNORMAL_NOTE_ENVELOPE_NUMBER, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _MH_ON:			/* n[hEFAGtFNg */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( (cmd->param[0] != 255) 
						 && (cmd->param[0] < 0 || cmd->param[0] > 15) ) { 
							dispError( ABNORMAL_HARD_EFFECT_NUMBER, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _DETUNE:			/* fB`[ */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( (cmd->param[0] != 255)
						 && (cmd->param[0] <-127 || cmd->param[0] > 126) ) {
							dispError( ABNORMAL_DETUNE_VALUE, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _TRANSPOSE:			/* gX|[Y */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( (cmd->param[0] != 255)
						 && (cmd->param[0] <-127 || cmd->param[0] > 126) ) {
							dispError( ABNORMAL_TRANSPOSE_VALUE, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
						transpose = cmd->param[0];
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _REPEAT_END:		/* s[gI */
				  case _REPEAT_END2:	/* s[gI */
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( cmd->param[0] < 2 ) {
							dispError( ABNORMAL_VALUE_OF_REPEAT_COUNT, lptr[line].filename, line );
							cmd->param[0] = 2;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _TEMPO2:			/* t[e| */
					ptr = setCommandBuf( 2, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( (cmd->param[0] <= 0) || (cmd->param[1] <= 0) ) {
							dispError( ABNORMAL_TEMPO_VALUE, lptr[line].filename, line );
							cmd->cmd = _NOP;
						} else {
							tbase = (double)cmd->param[0] * (double)cmd->param[1] / _BASE ;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _SWEEP:			/* XEB[v */
					ptr = setCommandBuf( 2, cmd, _SWEEP, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) != 0 ) {
						if( (cmd->param[0] < 0 || cmd->param[0] > 15)
						 || (cmd->param[1] < 0 || cmd->param[1] > 15) ) {
							dispError( ABNORMAL_SWEEP_VALUE, lptr[line].filename, line );
							cmd->cmd = 0;
							cmd->line = 0;
						}
					} else {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _DATA_WRITE:		/* f[^(WX^) */
					ptr = setCommandBuf( 2, cmd, _DATA_WRITE, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _DATA_THRUE:		/* f[^ڏ */
					ptr = setCommandBuf( 2, cmd, _DATA_THRUE, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;
				  case _DATA_BREAK:		/* f[^ϊ~ */
					setCommandBuf( 0, cmd, _TRACK_END, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;

				  case _NEW_BANK:						
					if (compatible_bkchg) {
						dispWarning( IGNORE_PMCKC_BANK_CHANGE, lptr[line].filename, line );
						cmd->cmd = _NOP;
						break;
					}
					ptr = setCommandBuf( 1, cmd, mml[i].num, ptr, line, mml[i].enable&(1<<trk) );
					if( (mml[i].enable&(1<<trk)) == 0 ) {
						dispWarning( UNUSE_COMMAND_IN_THIS_TRACK, lptr[line].filename, line );
					}
					break;

				  default:				/* ̑(G[) */
					dispError( COMMAND_NOT_DEFINED, lptr[line].filename, line );
					ptr++;
					break;
				}
				if( cmd->line != 0 ) {
					cmd++;
				}
			}
		} else if( lptr[line].status == _INCLUDE ) {
			cmd = analyzeData( trk, cmd, lptr[line].inc_ptr );
		}
	}
	return cmd;
}



/*--------------------------------------------------------------
	[v/A̓WJ
 Input:
	
 Output:
	
--------------------------------------------------------------*/
CMD *translateData( CMD **cmd, CMD *ptr )
{
	CMD		*top,*end,*temp;
	int		cnt ,i, loop;
	double	len, gate;

	loop = 0;
	gate = 0;
	top = ptr;
	end = NULL;

	while( 1 ) {
		switch( ptr->cmd ) {
		  case _REPEAT_ST:
			ptr++;
			nest++;
			ptr = translateData( cmd, ptr );
			nest--;
			break;
		  case _REPEAT_END:
			if( nest <= 0 ) {
				dispError( DATA_ENDED_BY_LOOP_DEPTH_EXCEPT_0, ptr->filename, ptr->line );
				ptr->cmd = _NOP;
				ptr++;
				break;
			}
			if( loop == 0 ) {
				loop = ptr->param[0];
				end = ptr+1;
			}
			if( loop == 1 ) {
				return end;
			}
			ptr = top;
			loop--;
			break;
		  case _REPEAT_ESC:
			if( nest <= 0 ) {
				dispError( DATA_ENDED_BY_LOOP_DEPTH_EXCEPT_0, ptr->filename, ptr->line );
				ptr->cmd = _NOP;
				ptr++;
				break;
			}
			if( loop == 1 ) {
				if( end != NULL ) {
					return end;
				}
			}
			ptr++;
			break;
		  case _CONT_NOTE:
			ptr++;
			temp = ptr;
			/* {} ̒[cdefgab]|n|@n|r|w邩? */
			cnt = 0;
			while( 1 ) {
				if( temp->cmd == _TRACK_END ) {
					dispError( DATA_ENDED_BY_CONTINUATION_NOTE, fname[0], (ptr-1)->line );
					setCommandBuf( 0, *cmd, _TRACK_END, NULL, ptr->line, 1 );
					break;
				} else if( temp->cmd == _CONT_END ) {
					if (cnt == 0) {
						dispError( TUPLET_BRACE_EMPTY, fname[0], (ptr-1)->line );
						len = 0;
					} else {
						/* {}̒g͑S̒ɂȂ */
						len = temp->len/(double)cnt;
					}
					break;
				} else if( temp->cmd <= MAX_NOTE || temp->cmd == _REST || temp->cmd == _KEY || temp->cmd == _NOTE || temp->cmd == _WAIT ) {
					cnt++;
				}
				temp++;
			}
			if( temp->cmd != _TRACK_END ) {
				while( ptr->cmd != _TRACK_END ) {
					if( ptr->cmd == _CONT_END ) {
						ptr++;
						break;
					} else if( ptr->cmd <= MAX_NOTE || ptr->cmd == _REST || ptr->cmd == _KEY || ptr->cmd == _NOTE || ptr->cmd == _WAIT ) {
						gate += len;
						(*cmd)->filename = ptr->filename;
						(*cmd)->cnt      = ptr->cnt;
						(*cmd)->frm      = ptr->frm;
						(*cmd)->line     = ptr->line;
						(*cmd)->cmd      = ptr->cmd;
						(*cmd)->len      = len;
						for( i = 0; i < 8; i++ ) { 
							(*cmd)->param[i] = ptr->param[i];
						}
						gate -= (*cmd)->len;
					} else if (ptr->cmd == _TIE) {
						/* Ã^C͍폜 */
						(*cmd)->filename = ptr->filename;
						(*cmd)->cnt      = 0;
						(*cmd)->frm      = 0;
						(*cmd)->line     = ptr->line;
						(*cmd)->cmd      = _NOP;
						(*cmd)->len      = 0;
					} else {
						(*cmd)->filename = ptr->filename;
						(*cmd)->cnt      = ptr->cnt;
						(*cmd)->frm      = ptr->frm;
						(*cmd)->line     = ptr->line;
						(*cmd)->cmd      = ptr->cmd;
						(*cmd)->len      = ptr->len;
						for( i = 0; i < 8; i++ ) { 
							(*cmd)->param[i] = ptr->param[i];
						}
					}
					(*cmd)++;
					ptr++;
				}

			}
			break;
		  case _TRACK_END:
			(*cmd)->filename = ptr->filename;
			(*cmd)->cnt      = ptr->cnt;
			(*cmd)->frm      = ptr->frm;
			(*cmd)->line     = ptr->line;
			(*cmd)->cmd      = ptr->cmd;
			(*cmd)->len      = ptr->len;
			for( i = 0; i < 8; i++ ) { 
				(*cmd)->param[i] = ptr->param[i];
			}
			(*cmd)++;
			ptr++;
			if( nest != 0 ) {
				dispError( DATA_ENDED_BY_LOOP_DEPTH_EXCEPT_0, fname[0], (ptr-1)->line );
			}
			return NULL;
		  default:
			(*cmd)->filename = ptr->filename;
			(*cmd)->cnt      = ptr->cnt;
			(*cmd)->frm      = ptr->frm;
			(*cmd)->line     = ptr->line;
			(*cmd)->cmd      = ptr->cmd;
			(*cmd)->len      = ptr->len;
			for( i = 0; i < 8; i++ ) { 
				(*cmd)->param[i] = ptr->param[i];
			}
			(*cmd)++;
			ptr++;
			break;
		}
	}
}



/*--------------------------------------------------------------
	
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void putAsm( FILE *fp, int data )
{
	if( x == 0 ) {
		fprintf( fp, "\tdb\t$%02x", data&0xff );
	} else if( x == 7 ) {
		fprintf( fp, ",$%02x\n",  data&0xff );
	} else {
		fprintf( fp, ",$%02x",  data&0xff );
	}
	if( ++x > 7 ) {
		x = 0;
	}
}


/*--------------------------------------------------------------
	
 Input:
	
 Output:
	
--------------------------------------------------------------*/
int double2int(double d)
{
	return (int)(d + 0.5);
}


/*--------------------------------------------------------------
	
 Input:
	
 Output:
	
--------------------------------------------------------------*/
void developeData( FILE *fp, int trk, CMD *cmd, LINE *lptr )
{
	CMD		*temp, *tempback, *cmdback;
	int		i, j, tone, sweep, quontize, chg_flag, note, len, gate;
	double	count, lcount, count_t;
	int		frame, lframe, frame_p, frame_d;
	double	rcount, rcount_esc, rcount_t, rcount_esc_t;
	int 	rframe, rframe_esc, rframe_err;
	int		repeat_esc_flag;
	LEN		loop_count;
	int		repeat_count;
	int		repeat_count0;
	char	path[256], name[256], ext[256];
	double	tbase_p;

	
	tbase = 0.625;
	length = 48;
	volume_flag = -1;
	tone = 0;
	sweep = 0;
	chg_flag = 0;

	env = -1; 
	rel_env = -1; 
	now_env = -1; 
 
	/* e|[N쐬 */
	temp = malloc( sizeof(CMD)*32*1024 );
	tempback = temp;
	for( i = 0; i < 32*1024; i++ ) {
		temp->cmd = 0;
		temp->cnt = 0;
		temp->frm = 0;
		temp->line = 0;
		for( j = 0; j < 8; j++ ) {
			temp->param[0] = 0;
		}
		temp++;
	}
	temp = tempback;
	/* `lf[^̓R}h́Aobt@ɂ߂ */
	temp = analyzeData( trk, temp, lptr );
	setCommandBuf( 0, temp, _TRACK_END, NULL, 0, 1 );
	temp = tempback;
	cmdback = cmd;
	nest = 0;
	translateData( &cmd, temp );
	cmd = cmdback;
	free( tempback );


	tbase = 0.625;

	/* JEgt[ɕϊ */
	loop_flag = 0;
	temp = cmd;
	count = 0;
	frame = 0;
	lcount = 0;
	lframe = 0;
	count_t = 0;
	repeat_count0 = 0;
	do {
		cmd->cnt = count;
		cmd->frm = frame;
		cmd->lcnt = lcount;
		cmd->lfrm = lframe;

//		printf("%s:%d:%4x %f %d %f\n", cmd->filename, cmd->line, cmd->cmd, cmd->cnt, cmd->frm, cmd->len);

		if( cmd->cmd == _REPEAT_ST2 ) {
			rcount = 0;
			rcount_esc = 0;
			rframe = 0;
			rframe_esc = 0;
			rcount_t = 0;
			rcount_esc_t = 0;
			repeat_count = 0;
			repeat_esc_flag = 0;
			temp = cmd;
			cmd++;
			while( 1 ) {
				if( repeat_count == 0 ) {
					cmd->cnt = count;
					cmd->frm = frame;
					cmd->lcnt = lcount;
					cmd->lfrm = lframe;
				}
				if( cmd->cmd == _REPEAT_END2 ) {
					if( repeat_count != 0 ) {
						if( --repeat_count == 0 ) {
							count_t += rcount_t*(cmd->param[0]-2)+rcount_esc_t;
							count += rcount*(cmd->param[0]-2)+rcount_esc;
							frame += rframe*(cmd->param[0]-2)+rframe_esc;
							if( loop_flag != 0 ) {
								lcount += rcount*(cmd->param[0]-2)+rcount_esc;
								lframe += rframe*(cmd->param[0]-2)+rframe_esc;
							}
							/* t[␳ */
							rframe_err = double2int(count_t * tbase) - frame;
							if (rframe_err > 0) {
								//printf( "frame-correct: %d frame\n", rframe_err );
								if (rframe_err >= 3)
								{
									dispWarning(REPEAT2_FRAME_ERROR_OVER_3, cmd->filename, cmd->line);
								}
								/* 2004.09.02 ς߂
								cmd->param[1] = rframe_err;
								frame += rframe_err;
								if( loop_flag != 0 ) {
									lframe += rframe_err;
								}
								*/
							} else {
								cmd->param[1] = 0;
							}
							break;
						}
					} else {
						repeat_count = cmd->param[0];
					}
					cmd = temp;
				} else if( cmd->cmd == _REPEAT_ESC2 ) {
					repeat_esc_flag = 1;
				} else if( cmd->cmd <= MAX_NOTE || cmd->cmd == _REST || cmd->cmd == _TIE
						|| cmd->cmd == _KEY || cmd->cmd == _NOTE || cmd->cmd == _WAIT ) {
					if( repeat_count == 0 ) {
						count_t += cmd->len;
						rcount_t += cmd->len;
						frame_p = rframe;
						rframe = double2int(rcount_t * tbase);
						frame_d = rframe - frame_p;
						count += cmd->len;
						frame += frame_d;
/* ΃[v΍ */
						if( loop_flag != 0 ) {
							lcount += cmd->len;
							lframe += frame_d;
						}
						rcount += cmd->len;
						if( repeat_esc_flag == 0 ) {
							rcount_esc_t += cmd->len;
							rcount_esc += cmd->len;
							rframe_esc += frame_d;
						} 
					}
				} else if( cmd->cmd == _TEMPO ) {
					tbase_p = tbase;
					tbase = (double)_BASETEMPO / (double)cmd->param[0];
					count_t = count_t * tbase / tbase_p;
					rcount_t = rcount_t * tbase / tbase_p;
					rcount_esc_t = rcount_esc_t * tbase / tbase_p;
				} else if( cmd->cmd == _TEMPO2 ) {
					tbase_p = tbase;
					tbase = (double)cmd->param[0] * (double)cmd->param[1] / _BASE;
					count_t = count_t * tbase / tbase_p;
					rcount_t = rcount_t * tbase / tbase_p;
					rcount_esc_t = rcount_esc_t * tbase / tbase_p;
				} else if( cmd->cmd == _SONG_LOOP ) {
					loop_flag = 1;
				}
				cmd++;
			}
		} else if( cmd->cmd <= MAX_NOTE || cmd->cmd == _REST || cmd->cmd == _TIE
				|| cmd->cmd == _KEY || cmd->cmd == _NOTE || cmd->cmd == _WAIT ) {
			count_t += cmd->len;
			frame_p = frame;
			frame = double2int(count_t * tbase);
			frame_d = frame - frame_p;
			count += cmd->len;
/* ΃[v΍ */
			if( loop_flag != 0 ) {
				lcount += cmd->len;
				lframe += frame_d;
			}
		} else if( cmd->cmd == _TEMPO ) {
			tbase_p = tbase;
			tbase = (double)_BASETEMPO / (double)cmd->param[0];
			count_t = count_t * tbase_p / tbase;
		} else if( cmd->cmd == _TEMPO2 ) {
			tbase_p = tbase;
			tbase = (double)cmd->param[0] * (double)cmd->param[1] / _BASE;
			count_t = count_t * tbase_p / tbase;
		} else if( cmd->cmd == _SONG_LOOP ) {
			loop_flag = 1;
		}
	} while( cmd++->cmd != _TRACK_END );

	splitPath( fname[1], path, name, ext );
	//unCt܂ރt@CgȂv̑΍
	strcpy(name, "songdata");
	fprintf( fp, "\n%s_%02d:\n", name, trk );

	cmd = cmdback;
	x = 0;
	loop_flag = 0;
	quontize = 8;
	repeat_count = 0;

	// `go2aȉ΍
	if( (trk == BTRACK(0)) || (trk == BTRACK(1)) ) {
		putAsm( fp, 0xf9 );
		putAsm( fp, 0x08 );
	}
	// Opg/mCYgbN΍
	if( (trk == BTRACK(2)) || (trk == BTRACK(3)) ) {
		putAsm( fp, 0xfe );
		putAsm( fp, 0x8f );
	}

	do {
		switch( cmd->cmd ) {
		  case _NOP:
		  case _TEMPO:
		  case _OCTAVE:
		  case _OCT_UP:
		  case _OCT_DW:
		  case _LENGTH:
		  case _TRANSPOSE:
			cmd++;
			break;
		  case _ENVELOPE:
			putAsm( fp, 0xfd );
			if( trk != BFMTRACK ) {
				env = cmd->param[0]&0x7f; 
				now_env = env;
				putAsm( fp, env ); 
			} else {
				env = cmd->param[0]&0x3f|0xc0; 
				now_env = env; 
				putAsm( fp, env );
			} 
			now_env = env;
			cmd++; 
			break; 
		  case _REL_ENV: 
			if( cmd->param[0] == 255 ) { 
				rel_env = -1;
			} else if( trk != BFMTRACK ) { 
				rel_env = cmd->param[0]&0x7f; 
			} else {
				rel_env = cmd->param[0]&0x3f|0xc0;
			}
			cmd++;
			break;
		  case _VOLUME:
			putAsm( fp, 0xfd );
			if( trk == BFMTRACK || trk == BVRC6SAWTRACK) {
				env = (cmd->param[0]&0x3f)|0x80;
				putAsm( fp, env );
			} else {
				env = (cmd->param[0]&0x0f)|0x80;
				putAsm( fp, env );
			}
			now_env = env;
			cmd++;
			break;
		  case _HARD_ENVELOPE:
			putAsm( fp, 0xfd );
			env = ((cmd->param[0]&1)<<6)+(cmd->param[1]&0x3f);
			putAsm( fp, env ); 
			now_env = env;
			cmd++;
			break;
		  case _TONE:
			putAsm( fp, 0xfe );
			//vrc6pɐO(Ȃ)
			putAsm( fp, cmd->param[0]+0x80 );
			cmd++;
			break;
		  case _ORG_TONE:
			putAsm( fp, 0xfe );
			putAsm( fp, cmd->param[0]&0x7f );
			cmd++;
			break;
		  case _SONG_LOOP:
			loop_count.cnt = cmd->cnt;
			loop_count.frm = cmd->frm;
			fprintf( fp, "\n%s_%02d_lp:\n", name, trk );
			loop_flag = 1;
			x = 0;
			cmd++;
			break;
		  case _QUONTIZE:
			quontize = cmd->param[0];
			cmd++;
			break;
		  case _QUONTIZE2:
			quontize = -cmd->param[0];
			cmd++;
			break;
		  case _REST:
			len = 0;
			while( 1 ) {
				if( loop_flag == 0 ) {
					len += ((cmd+1)->frm-cmd->frm);
				} else {
					len += ((cmd+1)->lfrm-cmd->lfrm);
				}
				cmd++;
				if( cmd->cmd != _TIE ) {
					break;
				}
			}
			if( len == 0 ) {
				dispWarning( FRAME_LENGTH_IS_0, cmd->filename, cmd->line );
			} else {
				while( len != 0 ) {
					if( len > 0xff ) {
						putAsm( fp, 0xfc );
						putAsm( fp, 0xff );
						len -= 0xff;
					} else {
						putAsm( fp, 0xfc );
						putAsm( fp, len );
						len = 0;
					}
				}
			}
			break;
		  case _WAIT:
			len = 0;
			while( 1 ) {
				if( loop_flag == 0 ) {
					len += ((cmd+1)->frm-cmd->frm);
				} else {
					len += ((cmd+1)->lfrm-cmd->lfrm);
				}
				cmd++;
				if( cmd->cmd != _TIE ) {
					break;
				}
			}
			if( len == 0 ) {
				dispWarning( FRAME_LENGTH_IS_0, cmd->filename, cmd->line );
			} else {
				while( len != 0 ) {
					if( len > 0xff ) {
						putAsm( fp, 0xf4 );
						putAsm( fp, 0xff );
						len -= 0xff;
					} else {
						putAsm( fp, 0xf4 );
						putAsm( fp, len );
						len = 0;
					}
				}
			}
			break;
		  case _LFO_ON:
			putAsm( fp, 0xfb );
			if( (cmd->param[0]&0xff) == 0xff ) {
				putAsm( fp, 0xff );
			} else {
				putAsm( fp, cmd->param[0]&0x7f );
			}
			cmd++;
			break;
		  case _LFO_OFF:
			putAsm( fp, 0xfb );
			putAsm( fp, 0xff );
			cmd++;
			break;
		  case _DETUNE:
			putAsm( fp, 0xfa );
			if( cmd->param[0] >= 0 ) {
				putAsm( fp, ( cmd->param[0]&0x7f)|0x80 );
			} else {
				putAsm( fp, (-cmd->param[0])&0x7f );
			}
			cmd++;
			break;
		  case _SWEEP:
			putAsm( fp, 0xf9 );
			putAsm( fp, ((cmd->param[0]&0xf)<<4)+(cmd->param[1]&0xf) );
			cmd++;
			break;
		  case _EP_ON:
			putAsm( fp, 0xf8 );
			putAsm( fp, cmd->param[0]&0xff );
			cmd++;
			break;
		  case _EP_OFF:
			putAsm( fp, 0xf8 );
			putAsm( fp, 0xff );
			cmd++;
			break;
		  case _EN_ON:
			putAsm( fp, 0xf7 );
			putAsm( fp, cmd->param[0]&0xff );
			cmd++;
			break;
		  case _EN_OFF:
			putAsm( fp, 0xf7 );
			putAsm( fp, 0xff );
			cmd++;
			break;
		  case _MH_ON:
			putAsm( fp, 0xf3 );
			putAsm( fp, cmd->param[0]&0xff );
			cmd++;
			break;
		  case _MH_OFF:
			putAsm( fp, 0xf3 );
			putAsm( fp, 0xff );
			cmd++;
			break;

		  case _NEW_BANK:
			if (compatible_bkchg) {
				dispWarning( IGNORE_PMCKC_BANK_CHANGE, cmd->filename, cmd->line );
				break;
			}
			putAsm( fp, 0xee );
			fprintf( fp,"\n\tdb\tbank(%s_bnk%03d)*2\n",name,curr_bank);
			fprintf( fp,"\tdw\t%s_bnk%03d\n",name,curr_bank);
			fprintf( fp,"\n\t.bank\t%d\n",curr_bank);
			fprintf( fp,"\t.org\t$a000\n\n");
			fprintf( fp,"%s_bnk%03d:\n",name,curr_bank);

			curr_bank++;

			x = 0; // o͈ʒuNA
			cmd++;
			break;


		  case _KEY:
			note = cmd->param[0]&0x7ff;
			len = 0;
			while( 1 ) {
				if( loop_flag == 0 ) {
					len += ((cmd+1)->frm-cmd->frm);
				} else {
					len += ((cmd+1)->lfrm-cmd->lfrm);
				}					
				cmd++;
				if( cmd->cmd == _SLAR ) {
					cmd++;
				} else if( cmd->cmd != _TIE ) {
					break;
				}
			}
			if( quontize >= 0 ) {
				gate = (len*quontize)/8;
			} else {
				gate = len+quontize;
			}
			if( len != 0 && gate <= 0 ) {
				gate = 1;
			}
			if( len != 0 ) {
				if( quontize != 0 && quontize != 8 ) {		// NI^CY0/8ȊÔƂɃ[XGx[v
					if( now_env != env ) {					// ݂̃G׃[vorʂƕϊ̃Gx[vorʂႤ
						putAsm( fp, 0xfd );					// Gx[vo
						putAsm( fp, env );
						now_env = env;
					}
				}
				putAsm( fp, 0xf6 );
				putAsm( fp,  note    &0xff );
				putAsm( fp, (note>>8)&0x07 );
				len -= gate;
				if( gate > 0xff ) {
					putAsm( fp, 0xff );
					gate -= 0xff;
				} else {
					putAsm( fp, gate );
					gate = 0;
				}
				while( gate != 0 ) {
					if( gate > 0xff ) {
						putAsm( fp, 0xf4 );
						putAsm( fp, 0xff );
						gate -= 0xff;
					} else {
						putAsm( fp, 0xf4 );
						putAsm( fp, gate );
						gate = 0;
					}
				}
				gate += len;
				if( gate != 0 ) {
					if( (rel_env != -1 )					// Gx[v쒆
					 && (now_env != rel_env) ) {			// ݂̃G׃[vƕϊ̃Gx[vႤ
						putAsm( fp, 0xfd );					// Gx[vo
						putAsm( fp, rel_env );
						now_env = rel_env;
						note = 0xf4;
					} else {
						note = 0xfc;
					}
					while( gate != 0 ) {
						if( gate > 0xff ) {
							putAsm( fp, note );
							putAsm( fp, 0xff );
							gate -= 0xff;
						} else {
							putAsm( fp, note );
							putAsm( fp, gate );
							gate = 0;
						}
					}
				}
			} else {
				dispWarning( FRAME_LENGTH_IS_0, (cmd-1)->filename, (cmd-1)->line );
			}
			break;
		  case _DATA_WRITE:
			putAsm( fp, 0xf5 );
			putAsm( fp,  cmd->param[0]    &0xff );
			putAsm( fp, (cmd->param[0]>>8)&0xff );
			putAsm( fp,  cmd->param[1]    &0xff );
			cmd++;
			break;
		  case _DATA_THRUE:
			putAsm( fp,  cmd->param[0]    &0xff );
			putAsm( fp,  cmd->param[1]    &0xff );
			cmd++;
			break;
		  case _REPEAT_ST2:
			fprintf( fp, "\n%s_%02d_lp_%04d:\n", name, trk, repeat_count0 );
			repeat_count++;
			x = 0;
			cmd++;
			break;
		  case _REPEAT_END2:
			if( --repeat_count < 0 ) {
				dispError( DATA_ENDED_BY_LOOP_DEPTH_EXCEPT_0, cmd->filename, cmd->line );
			} else {
				putAsm( fp, 0xa0 );
				putAsm( fp, cmd->param[0]&0x7f );
				fprintf( fp, "\n\tdw\t%s_%02d_lp_%04d\n", name, trk, repeat_count0 );
				fprintf( fp, "%s_%02d_lp_exit_%04d:\n", name, trk, repeat_count0 );
				repeat_count0++;
				x = 0;
				/* 2004.09.02 ς߂
				if ( cmd->param[1] > 0 ) {
					putAsm( fp, 0xf4 );
					putAsm( fp, cmd->param[1]&0xFF);
				} */
			}
			cmd++;
			break;
		  case _REPEAT_ESC2:
			if( (repeat_count-1) < 0 ) {
				dispError( DATA_ENDED_BY_LOOP_DEPTH_EXCEPT_0, cmd->filename, cmd->line );
			} else {
				putAsm( fp, 0xa1 );
				fprintf( fp, "\n\tdw\t%s_%02d_lp_exit_%04d\n", name, trk, repeat_count0 );
				x = 0;
			}
			cmd++;
			break;
		  case _TRACK_END:
			break;
		  default:
			note = cmd->cmd;
			if( MIN_NOTE <= note && note <= MAX_NOTE ) {
				len = 0;
				while( 1 ) {
					if( loop_flag == 0 ) {
						len += ((cmd+1)->frm-cmd->frm);
					} else {
						len += ((cmd+1)->lfrm-cmd->lfrm);
					}
					cmd++;
					if( cmd->cmd == _SLAR ) {
						cmd++;
					} else if( cmd->cmd != _TIE ) {
						break;
					}
				}
				if( quontize >= 0 ) {
					gate = (len*quontize)/8;
				} else {
					gate = len+quontize;
				}
				if( len != 0 && gate <= 0 ) {
					gate = 1;
				}
				if( len != 0 ) {
					if( quontize != 0 && quontize != 8 ) {		// NI^CY0/8ȊÔƂɃ[XGx[v
						if( now_env != env ) {					// ݂̃G׃[vorʂƕϊ̃Gx[vorʂႤ
							putAsm( fp, 0xfd );					// Gx[vo
							putAsm( fp, env );
							now_env = env;
						}
					}
					len -= gate;
					if( note < 0 ) {				/* Œቹ̑΍ */
						note += 16;
					}
					putAsm( fp, note );
					if( gate > 0xff ) {
						putAsm( fp, 0xff );
						gate -= 0xff;
					} else {
						putAsm( fp, gate );
						gate = 0;
					}
					// EFCgǉ
					while( gate != 0 ) {
						if( gate > 0xff ) {
							putAsm( fp, 0xf4 );
							putAsm( fp, 0xff );
							gate -= 0xff;
						} else {
							putAsm( fp, 0xf4 );
							putAsm( fp, gate );
							gate = 0;
						}
					}
					// x(NI^CY)
					gate += len;
					if( gate != 0 ) {
						if( (rel_env != -1 )					// Gx[v쒆
						 && (now_env != rel_env) ) {			// ݂̃G׃[vƕϊ̃Gx[vႤ
							putAsm( fp, 0xfd );					// Gx[vo
							putAsm( fp, rel_env );
							now_env = rel_env;
							note = 0xf4;
						} else {
							note = 0xfc;
						}
						while( gate != 0 ) {
							if( gate > 0xff ) {
								putAsm( fp, note );
								putAsm( fp, 0xff );
								gate -= 0xff;
							} else {
								putAsm( fp, note );
								putAsm( fp, gate );
								gate = 0;
							}
						}
					}
				} else {
					dispWarning( FRAME_LENGTH_IS_0, (cmd-1)->filename, (cmd-1)->line );
				}
			} else {
				cmd++;
			}
		}
	} while( cmd->cmd != _TRACK_END );

	track_count[trk][0].cnt = cmd->cnt;
	track_count[trk][0].frm = cmd->frm;

	if( loop_flag == 0 ) {
		track_count[trk][1].cnt = 0;
		track_count[trk][1].frm = 0;

		fprintf( fp, "\n%s_%02d_lp:\n", name, trk );
		x = 0;
		putAsm( fp, 0xfc );
		putAsm( fp, 0xff );
		putAsm( fp, 0xff );
	} else {
		track_count[trk][1].cnt = cmd->lcnt;
		track_count[trk][1].frm = cmd->lfrm;
		putAsm( fp, 0xff );
	}
	fputc( '\n', fp );
}


/*--------------------------------------------------------------
	Ug\[`
	i:trk number
	trk: track symbol
--------------------------------------------------------------*/

void display_counts_sub(int i, char trk)
{
	printf( "   %c   |", trk);
	if( track_count[i][0].cnt != 0 ) {
		printf (" %6d   %5d|", double2int(track_count[i][0].cnt), track_count[i][0].frm );
	} else {
		printf( "               |" );
	}
	if( track_count[i][1].cnt != 0 ) {
		printf (" %6d   %5d|\n", double2int(track_count[i][1].cnt),track_count[i][1].frm );
	} else {
		printf( "               |\n" );
	}
}



/*--------------------------------------------------------------
	f[^쐬[`
 Input:
	
 Output:
	
--------------------------------------------------------------*/
int data_make( void )
{
	FILE	*fp;
	int		i, j, line_max, track_ptr;
	int		tone_max, envelope_max, pitch_env_max, pitch_mod_max;
	int		arpeggio_max, fm_tone_max, dpcm_max, n106_tone_max,vrc7_tone_max;
	int		hard_effect_max, effect_wave_max;
	char	*ptr;
	char	path[256],name[256],ext[256];
	LINE	*line_ptr;
	CMD		*cmd_buf;
	int	trk_flag[_TRACK_MAX];

	/* MMLt@Cǂݍ	*/
	ptr = readFile( fname[0], "rt" );
	if( ptr == NULL ) return 0;

	/* MMLf[^̃Rgs폜 */
	deleteCRemark( ptr );
	deleteRemark(  ptr );
	/* TEXTs擾	*/
	line_max = getLineCount( ptr );
	line_ptr = malloc( (line_max+1)*sizeof(LINE) );
	line_ptr->status = _HEADER;
	line_ptr->str    = ptr;
	line_ptr->line   = line_max;				/* line_ptr[0].line͑C */

	line_ptr->filename = fname[0];
	for( i = 1; i <= line_max; i++ ) {
		line_ptr[i].filename = fname[0];
		line_ptr[i].line = i;
	}

	for(i=0; i < _TRACK_MAX; i++) bank_sel[i]=0xFF; // Ԃ͐؂ւ

	getLineStatus( ptr, line_ptr, 0 );

#if DEBUG
	for( i = 1; i < line_max; i++ ) {
		printf( "%4d : %04x\n", i, line_ptr[i].status );
	}
#endif

	/* F^Gx[vf[^擾& */
	for( i = 0; i < _TONE_MAX; i++ )           tone_tbl[i][0] = 0;
	for( i = 0; i < _ENVELOPE_MAX; i++ )   envelope_tbl[i][0] = 0;
	for( i = 0; i < _PITCH_ENV_MAX; i++ ) pitch_env_tbl[i][0] = 0;
	for( i = 0; i < _PITCH_MOD_MAX; i++ ) pitch_mod_tbl[i][0] = 0;
	for( i = 0; i < _DPCM_MAX; i++ ) {
		dpcm_tbl[i].flag = 0;
		dpcm_tbl[i].index = -1;
	}
	for( i = 0; i < _FM_TONE_MAX; i++ ) {
		for( j = 0; j < 66; j++ ) {         fm_tone_tbl[i][j] = 0; }
	}
	for( i = 0; i < _N106_TONE_MAX; i++ ) n106_tone_tbl[i][0] = 0;

	getTone(     line_ptr );
	getEnvelope( line_ptr );
	getPitchEnv( line_ptr );
	getPitchMod( line_ptr );
	getArpeggio( line_ptr );
	getDPCM(     line_ptr );
	getFMTone(   line_ptr );
	getVRC7Tone( line_ptr );
	getN106Tone( line_ptr );
	getHardEffect(line_ptr);
	getEffectWave(line_ptr);

	tone_max      = checkLoop(       tone_tbl,      _TONE_MAX );
	envelope_max  = checkLoop(   envelope_tbl,  _ENVELOPE_MAX );
	pitch_env_max = checkLoop(  pitch_env_tbl, _PITCH_ENV_MAX );
	pitch_mod_max = getMaxLFO(  pitch_mod_tbl, _PITCH_MOD_MAX );
	arpeggio_max  = checkLoop(   arpeggio_tbl,  _ARPEGGIO_MAX );
	dpcm_max      = getMaxDPCM( dpcm_tbl );
	fm_tone_max   = getMaxTone(   fm_tone_tbl,   _FM_TONE_MAX );
	n106_tone_max = getMaxTone( n106_tone_tbl, _N106_TONE_MAX );
	vrc7_tone_max = getMaxTone( vrc7_tone_tbl, _VRC7_TONE_MAX );
	hard_effect_max = getMaxHardEffect( hard_effect_tbl, _HARD_EFFECT_MAX );
	effect_wave_max = getMaxEffectWave( effect_wave_tbl, _EFFECT_WAVE_MAX );

	sortDPCM( dpcm_tbl );					// F̃_u폜
	checkDPCMSize( dpcm_tbl );
	dpcm_size = getDPCMTotalSize( dpcm_tbl );
	if( dpcm_size > _DPCM_TOTAL_SIZE ) {	// TCY`FbN
		dispError( DPCM_FILE_TOTAL_SIZE_OVER, NULL, 0 );
		dpcm_size = 0;
	} else {
		readDPCM( dpcm_tbl );
	}

	/* FɃtOǉ */
//mckłĂ炤Ƃɂ
#if	0
	for( i = 0; i < tone_max; i++ ) {
		if( tone_tbl[i][0] != 0 ) {
			for( j = 1; j <= tone_tbl[i][0]; j++ ) {
				if( tone_tbl[i][j] <= 3 ) {
					tone_tbl[i][j] = (tone_tbl[i][j]<<2)+3;
				}
			}
		}
	}
#endif
	/* sb`Gx[ṽp[^C */
	for( i = 0; i < pitch_env_max; i++ ) {
		if( pitch_env_tbl[i][0] != 0 ) {
			for( j = 1; j <= pitch_env_tbl[i][0]; j++ ) {
				if( 0 < pitch_env_tbl[i][j] && pitch_env_tbl[i][j] < 127 ) {
					pitch_env_tbl[i][j] = pitch_env_tbl[i][j]|0x80;
				} else if( 0 >= pitch_env_tbl[i][j] && pitch_env_tbl[i][j] >= -127 ) {
					pitch_env_tbl[i][j] = (0-pitch_env_tbl[i][j]);
				}
			}
		}
	}

	if( 1/*ef_out_flag != 0*/ ) {

		fp = fopen( inc_name, "wt" );
		if( fp == NULL ) {
			if( message_flag == 0 ) {
				printf( "%s : t@C쐬ł܂łB~܂B\n", inc_name );
			} else {
				printf( "%s : Don't create file. Stops.\n", inc_name );
			}
			return -1;
		}

		fprintf( fp, "SOUND_GENERATOR\tequ\t$%02x\n", sndgen_flag );
		track_ptr = 0;
		track_ptr += 4;
		fprintf( fp, "PTRDPCM\t\tequ\t%2d\n", track_ptr);
		track_ptr += dpcm_track_num;
		fprintf( fp, "PTRFDS\t\tequ\t%2d\n", track_ptr);
		track_ptr += fds_track_num;
		fprintf( fp, "PTRVRC7\t\tequ\t%2d\n", track_ptr);
		track_ptr += vrc7_track_num;
		fprintf( fp, "PTRVRC6\t\tequ\t%2d\n", track_ptr);
		track_ptr += vrc6_track_num;
		fprintf( fp, "PTRN106\t\tequ\t%2d\n", track_ptr);
		track_ptr += n106_track_num;
		fprintf( fp, "PTRFME7\t\tequ\t%2d\n", track_ptr);
		track_ptr += fme7_track_num;
		fprintf( fp, "PTRMMC5\t\tequ\t%2d\n", track_ptr);
		track_ptr += mmc5_track_num;
		fprintf( fp, "PTR_TRACK_END\t\tequ\t%2d\n", track_ptr);
		
		//fprintf( fp, "INITIAL_WAIT_FRM\t\tequ\t$%02d\n", 0x26);

		
		if (compatible_bkchg) {
			fprintf( fp, "EMC\t\tequ\t1\n");
		} else {
			fprintf( fp, "EMC\t\tequ\t0\n");
		}
		
		/* o̓t@CɃ^Cg/Ȏ/łݎ҂̏}NƂď */
		getSongInfo(line_ptr);
		writeSongInfoMacro(fp);

		fprintf(fp,"\n\n");
		fclose( fp );

		fp = fopen( ef_name, "wt" );
		if( fp == NULL ) {
			if( message_flag == 0 ) {
				printf( "%s : t@C쐬ł܂łB~܂B\n", ef_name );
			} else {
				printf( "%s : Don't create file. Stops.\n", ef_name );
			}
			return -1;
		}
		// MMLt@C
		if( include_flag != 0 ) {
			fprintf( fp, "\t.include\t\"%s\"\n", fname[1] );
		}

		
		if (!compatible_bkchg) {
			fprintf(fp,"\t.bank\t0\n");
		}


		/* F */
		writeTone( fp, tone_tbl, "dutyenve", tone_max );
		/* Gx[v */
		writeTone( fp, envelope_tbl, "softenve", envelope_max );
		/* sb`Gx[v */
		writeTone( fp, pitch_env_tbl, "pitchenve", pitch_env_max );
		/* m[gGx[v */
		writeTone( fp, arpeggio_tbl, "arpeggio", arpeggio_max );
		/* LFO */
		fprintf( fp,"lfo_data:\n" );
		if( pitch_mod_max != 0 ) {
			for( i = 0; i < pitch_mod_max; i++ ) {
				if( pitch_mod_tbl[i][0] != 0 ) {
					fprintf( fp, "\tdb\t$%02x,$%02x,$%02x,$%02x\n",
						pitch_mod_tbl[i][1], pitch_mod_tbl[i][2],
						pitch_mod_tbl[i][3], pitch_mod_tbl[i][4] );
				} else {
					fprintf( fp, "\tdb\t$00,$00,$00,$00\n" );
				}
			}
			fprintf( fp, "\n" );
		}
		/* FMF */
		writeToneFM( fp, fm_tone_tbl, "fds", fm_tone_max );
		writeHardEffect( fp, hard_effect_tbl, "fds", hard_effect_max );
		writeEffectWave( fp, effect_wave_tbl, "fds", effect_wave_max );
		/* namco106F */
		writeToneN106( fp, n106_tone_tbl, "n106", n106_tone_max );
		/* VRC7F */
		writeToneVRC7( fp, vrc7_tone_tbl, "vrc7", vrc7_tone_max );
		/* DPCM */
		writeDPCM( fp, dpcm_tbl, "dpcm_data", dpcm_max );
			
		fclose( fp );
	}

	/* MML->ASMf[^ϊ */
	fp = fopen( fname[1], "wt" );
	if( fp == NULL ) {
		if( message_flag == 0 ) {
			printf( "%s : t@C쐬ł܂łB~܂B\n", ef_name );
		} else {
			printf( "%s : Don't create file. Stops.\n", ef_name );
		}
		return -1;
	}

	/* o̓t@CɃ^Cg/Ȏ/łݎ҂̏RgƂď */
	writeSongInfo(fp, line_ptr);
	checkOctaveRev( line_ptr );

	//printf(" test info:vrc7:%d vrc6:%d n106:%d\n",vrc7_track_num,vrc6_track_num, n106_track_num);

	for(i=0; i < _TRACK_MAX; i++) trk_flag[i]=0;

	for(i=0; i <= BNOISETRACK; i++) trk_flag[i]=1;
	
	trk_flag[BDPCMTRACK]=1;
		
	if (fds_track_num)
		trk_flag[BFMTRACK]=1;
		
	if (vrc7_track_num)
		for(i=BVRC7TRACK; i < BVRC7TRACK+vrc7_track_num; i++) trk_flag[i]=1;
	if (vrc6_track_num)
		for(i=BVRC6TRACK; i < BVRC6TRACK+vrc6_track_num; i++) trk_flag[i]=1;
	if (n106_track_num)
		for(i=BN106TRACK; i < BN106TRACK+n106_track_num; i++) trk_flag[i]=1;
	if (fme7_track_num)
		for(i=BFME7TRACK; i < BFME7TRACK+fme7_track_num; i++) trk_flag[i]=1;
	if (mmc5_track_num)
		for(i=BMMC5TRACK; i < BMMC5TRACK+mmc5_track_num; i++) trk_flag[i]=1;

	splitPath( fname[1], path, name, ext );
	//unCt܂ރt@CgȂv̑΍
	strcpy(name, "songdata");
	fprintf( fp, "sound_data_table:\n" );
	for( i = 0; i < _TRACK_MAX; i++ ){
		if (trk_flag[i]) fprintf( fp, "\tdw\t%s_%02d\n", name, i );
	}
	fprintf( fp, "loop_point_table:\n" );
	for( i = 0; i < _TRACK_MAX; i++ ){
		if (trk_flag[i]) fprintf( fp, "\tdw\t%s_%02d_lp\n", name, i );
	}

	if (!compatible_bkchg) {
		fprintf( fp, "sound_data_bank:\n" );
		for( i = 0; i < _TRACK_MAX; i++ ){
			if (trk_flag[i]) fprintf( fp, "\tdb\tbank(%s_%02d)*2\n", name, i );
		}
		fprintf( fp, "loop_point_bank:\n" );
		for( i = 0; i < _TRACK_MAX; i++ ){
			if (trk_flag[i]) fprintf( fp, "\tdb\tbank(%s_%02d_lp)*2\n", name, i );
		}
	}



//	printf( "%2x, %2x, %2x\n", bank_change[0],  bank_change[1], bank_change[2] );

	curr_bank = 0x04;

	/* gbNPʂŃf[^ϊ */
	for( i = 0; i < _TRACK_MAX; i++ ) {
		if (compatible_bkchg) {
			if( i == bank_change[0] ) {
				fprintf( fp, "\t.bank\t1\n\t.org\t$a000\n" );
			}
			if( i == bank_change[1] ) {
				fprintf( fp, "\t.bank\t2\n\t.org\t$c000\n" );
			}
			if( i == bank_change[2] ) {
				fprintf( fp, "\t.bank\t3\n\t.org\t$e000\n" );
			}
		}
		if (trk_flag[i]) {
			if (!compatible_bkchg) {
				if ( bank_sel[i] != 0xff ) {
					fprintf( fp, "\n\n");
					fprintf( fp, "\t.bank\t%d\n\t.org\t$a000\n",bank_sel[i]);
					curr_bank = bank_sel[i]+1; // 
				}
			}
			cmd_buf = malloc( sizeof(CMD)*32*1024 );
			developeData( fp, i, cmd_buf, line_ptr );
			free( cmd_buf );
		}
	}
	fclose( fp );

	if( error_flag == 0 ) {
		putchar( '\n' ); 
		printf(	"-------+---------------+---------------+\n"
			"Track  |     Total     |     Loop      |\n"
			" Symbol|(count)|(frame)|(count)|(frame)|\n"
			"-------+-------+-------+-------+-------+\n");
		for (i = 0; i < _TRACK_MAX; i++) {
			if (trk_flag[i])
				display_counts_sub(i, str_track[i]);
		}
		printf(	"-------+-------+-------+-------+-------+\n");
	} else {
		remove( fname[1] );				/* G[Ƃ͏o̓t@C폜 */
		if( ef_out_flag != 0 ) {
			remove( ef_name );
		}
	}
	return 0;
}
